<?php 
error_reporting(32767 & ~8 & ~8192);
define("THIS_SCRIPT", "plugins");
define("NO_GZ", 0);
define("DIM_AREA", "admincp");
define("CSRF_PROTECTION", true);
chdir("./../");
define("CWD", ($getcwd = getcwd()) ? $getcwd : ".");
include_once(CWD . "/include/functions_admin.php");
include_once(CWD . "/include/functions_build.php");
if( !is_permissioned_to("dimcp", "cctrladvtool") ) 
{
    perm_denied();
}

if( !$dimofinf->options["pluginsactive"] ) 
{
    error_message(fetch_message("plugins_disabled"));
}

if( empty($dimofinf->GPC["action"]) ) 
{
    $dimofinf->GPC["action"] = "list";
}

$dimofinf->input->clean_array_gpc("r", array( "folder" => TYPE_STR ));
include_once(DIR . "/include/functions_user_input.php");
$cleaned = clean_user_input($dimofinf->GPC["folder"], true);
$dimofinf->GPC["folder"] = $cleaned["text"];
$storemodule = "store";
$storepostfields = array(  );
$storepostfields["datatype"] = "json";
$storepostfields["module"] = $storemodule;
$storepostfields["ftphost"] = $dimofinf->options["dimftphost"];
$storepostfields["ftpuser"] = $dimofinf->options["dimftpuser"];
$storepostfields["ftppass"] = decodpass($dimofinf->options["dimftppass"]);
$storepostfields["ftpport"] = (int) $dimofinf->options["dimftpport"];
$storepostfields["ftpfolder"] = $dimofinf->options["dimftpfolder"];
$storepostfields["username"] = $dimofinf->options["storeusername"];
$storepostfields["password"] = decodpass($dimofinf->options["storepassword"]);
$storepostfields["licensekey"] = $dimofinf->config["LicenseKey"];
$storepostfields["usessl"] = (int) $dimofinf->options["dimusessl"];
if( $dimofinf->GPC["action"] == "installstorestyle" ) 
{
    if( function_exists("set_time_limit") && !SAFEMODE ) 
    {
        @set_time_limit(0);
    }

    $dimofinf->input->clean_array_gpc("g", array( "version" => TYPE_STR, "pluginid" => TYPE_UINT ));
    $storepostfields["action"] = "uploadPlugin";
    $storepostfields["version"] = $dimofinf->GPC["version"];
    $storepostfields["pluginid"] = $dimofinf->GPC["pluginid"];
    $storepostfields["uploadnew"] = true;
    $storeresult = connect_with_host(STORE_URL, "api.php", $storepostfields);
    $result = json_decode($storeresult, true);
    if( is_array($result) ) 
    {
        if( $result["result"] == "success" ) 
        {
            $_REQUEST["reffurl"] = "style.php?action=add&title=" . str_ireplace(" ", "_", $license["styles"][$dimofinf->GPC["folder"]]["name"]) . "&folder=" . $dimofinf->GPC["folder"] . "&pwidth=1250px";
            success_message(fetch_message("content_added", $dimofinf->userinfo["displayname"]));
        }
        else
        {
            print_error_message("plugins_store_error", $license["styles"][$dimofinf->GPC["folder"]]["name"], $result["data"]);
        }

    }
    else
    {
        print_error_message("plugins_store_error", $license["styles"][$dimofinf->GPC["folder"]]["name"], $storeresult);
    }

}

if( $dimofinf->GPC["action"] == "upgradestoreplugin" ) 
{
    if( function_exists("set_time_limit") && !SAFEMODE ) 
    {
        @set_time_limit(0);
    }

    $dimofinf->input->clean_array_gpc("g", array( "version" => TYPE_STR, "pluginid" => TYPE_UINT ));
    if( $is_installed = $hook->check_plugin_is_installed($dimofinf->GPC["folder"]) ) 
    {
        $dimofinf->GPC["id"] = $is_installed;
    }

    $storepostfields["action"] = "uploadPlugin";
    $storepostfields["version"] = $dimofinf->GPC["version"];
    $storepostfields["pluginid"] = $dimofinf->GPC["pluginid"];
    $storeresult = connect_with_host(STORE_URL, "api.php", $storepostfields);
    $result = json_decode($storeresult, true);
    if( is_array($result) ) 
    {
        if( $result["result"] == "success" ) 
        {
            $dimofinf->GPC["action"] = "upgrade";
        }
        else
        {
            print_error_message("plugins_store_error", $license["plugins"][$dimofinf->GPC["folder"]]["name"], $result["data"]);
        }

    }
    else
    {
        print_error_message("plugins_store_error", $license["plugins"][$dimofinf->GPC["folder"]]["name"], $storeresult);
    }

}

if( $dimofinf->GPC["action"] == "installstoreplugin" ) 
{
    if( function_exists("set_time_limit") && !SAFEMODE ) 
    {
        @set_time_limit(0);
    }

    $dimofinf->input->clean_array_gpc("g", array( "version" => TYPE_STR, "pluginid" => TYPE_UINT ));
    $storepostfields["action"] = "uploadPlugin";
    $storepostfields["version"] = $dimofinf->GPC["version"];
    $storepostfields["pluginid"] = $dimofinf->GPC["pluginid"];
    $storepostfields["uploadnew"] = true;
    $storeresult = connect_with_host(STORE_URL, "api.php", $storepostfields);
    $result = json_decode($storeresult, true);
    if( is_array($result) ) 
    {
        if( $result["result"] == "success" ) 
        {
            $dimofinf->GPC["action"] = "install";
        }
        else
        {
            print_error_message("plugins_store_error", $license["plugins"][$dimofinf->GPC["folder"]]["name"], $result["data"]);
        }

    }
    else
    {
        print_error_message("plugins_store_error", $license["plugins"][$dimofinf->GPC["folder"]]["name"], $storeresult);
    }

}

if( $dimofinf->GPC["action"] == "storeproducts" ) 
{
    header("Cache-Control: no-cache, must-revalidate");
    header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
    header("Content-Type: text/html; charset=" . LANG_CHARSET . "");
    header("Content-language: " . LANG_CODE . "");
    $storepostfields["action"] = "getLatest";
    $storepostfields["page"] = $dimofinf->GPC["page"] ? $dimofinf->GPC["page"] : 1;
    $storepostfields["limit"] = "12";
    $notin = array(  );
    if( is_array($license["plugins"]) ) 
    {
        foreach( $license["plugins"] as $key => $val ) 
        {
            $notin[] = $val["pluginid"];
        }
        $storepostfields["notin"] = json_encode($notin);
    }

    $latestproducts = json_decode(connect_with_host(STORE_URL, "api.php", $storepostfields), true);
    if( $latestproducts["result"] == "success" ) 
    {
        foreach( $latestproducts["data"] as &$product ) 
        {
            if( 125 < mb_strlen($product["description"], "UTF-8") ) 
            {
                $product["description"] = mb_substr($product["description"], 0, 125) . "..";
            }

            echo "<div style=\"margin-" . LANG_LEFT . ":8px;width: 250px;float: " . LANG_LEFT . ";\"class=\"list-group\">\r\n                 <a href=\"#\" class=\"unclickable list-group-item active\" style=\"background-color: #354159;border-color: #354159;\">" . $product["caption"] . "</a>\r\n                 <a href=\"#\" class=\"unclickable available list-group-item\"><img src=\"" . $product["imgth"] . "\"></a>\r\n                <a href=\"#\" class=\"unclickable pdescription list-group-item\">" . $product["description"] . "</a>\r\n                <a href=\"" . STORE_URL . $storemodule . "/s/" . $product["id"] . "\" target=\"_blank\" class=\"list-group-item\"><span class=\"tcen\"><input class=\"button\" type=\"submit\" value=\"" . $dimphrase["view"] . "\" name=\"submit\"></span></a>\r\n                </div><script>\r\n\$(\".unclickable\").click(function (e) {\r\ne.preventDefault();\r\n});\r\n</script>";
        }
        $count["total"] = $latestproducts["data"][0]["total"];
        $perpage = $storepostfields["limit"];
        if( $storepostfields["page"] < 1 ) 
        {
            $storepostfields["page"] = 1;
        }
        else
        {
            if( ceil(($count["total"] + 1) / $perpage) < $storepostfields["page"] ) 
            {
                $storepostfields["page"] = ceil(($count["total"] + 1) / $perpage);
            }

        }

        $limit = ($storepostfields["page"] - 1) * $perpage;
        echo "<div class=\"clearfix\"></div>";
        echo prev_next($storepostfields["page"], $perpage, $count["total"], "storeproducts", "", true, "products");
    }
    else
    {
        echo "<div class=\"alert alert-danger\" role=\"alert\">Error:" . $latestproducts["data"] . "</div>";
    }

}

if( $dimofinf->GPC["action"] == "list" ) 
{
    print_cp_header($dimphrase["menu_plugins_manager"]);
    echo "<style>\r\n.bs-plugins {\r\nmargin-" . LANG_RIGHT . ": 13px;\r\nmargin-" . LANG_LEFT . ": 5px;\r\n}\r\n.bs-plugins_title {\r\nposition: absolute;\r\ntop: 15px;\r\nfont-size: 14px;\r\nfont-weight: 700;\r\ncolor: #959595;\r\ntext-transform: uppercase;\r\nletter-spacing: 1px;\r\n}\r\n\r\n.available img{\r\nwidth:200px;\r\nheight:200px;\r\n}\r\n.available{\r\ntext-align:center;\r\n}\r\n.pdescription{\r\nheight:110px;\r\n}\r\n</style>        \r\n<div class=\"bs-plugins bs-plugins-tabs\" role=\"tabpanel\" data-plugins-id=\"togglable-tabs\">\r\n<div class=\"bs-plugins_title\"><i class=\"icon-power-cord\"></i>  " . $dimphrase["menu_plugins_manager"] . "</div>\r\n<br /><br />\r\n    <ul id=\"myTab\" class=\"nav nav-tabs\" role=\"tablist\">\r\n      <li role=\"presentation\" class=\"active\"><a href=\"#installed\" id=\"installed-tab\" role=\"tab\" data-toggle=\"tab\" aria-controls=\"installed\" aria-expanded=\"true\"><i class=\"glyphicon glyphicon-saved\"></i> Installed</a></li>\r\n      <li role=\"presentation\"><a href=\"#available\" role=\"tab\" id=\"available-tab\" data-toggle=\"tab\" aria-controls=\"available\"><i class=\"glyphicon glyphicon-cloud-download\"></i> Available</a></li>\r\n      <li role=\"presentation\"><a href=\"#updates\" role=\"tab\" id=\"updates-tab\" data-toggle=\"tab\" aria-controls=\"updates\"><i class=\"glyphicon glyphicon-import\"></i> Updates</a></li>\r\n      <li role=\"presentation\"><a href=\"#styles\" role=\"tab\" id=\"styles-tab\" data-toggle=\"tab\" aria-controls=\"styles\"><i class=\"glyphicon glyphicon-import\"></i> Styles</a></li>\r\n      <li role=\"presentation\" onclick=\"DIM_showinline('products','plugins.php?action=storeproducts&p=1&ajax=ajax',this); return false;\"><a href=\"#latestproducts\" role=\"tab\" id=\"latestproducts-tab\" data-toggle=\"tab\" aria-controls=\"latestproducts\"><i class=\"glyphicon glyphicon-shopping-cart\"></i> Store Latest</a></li>\r\n      \r\n    </ul>\r\n    <div id=\"myTabContent\" class=\"tab-content\">\r\n      <div role=\"tabpanel\" class=\"tab-pane fade in active\" id=\"installed\" aria-labelledby=\"installed-tab\"><br />";
    print_table_start(false);
    print_cells_row(array( $dimphrase["name"], $dimphrase["action"] ), 1, "ptitle", -1, "", 0, 0, array( 1 => 2, 2 => 3, 3 => 3 ));
    $plugins = $hook->get_plugins_data();
    foreach( (array) $license["plugins"] as $key => $val ) 
    {
        if( !empty($plugins[$key]) && array_key_exists($key, $plugins) && $hook->check_plugin_is_installed($plugins[$key]["folder"]) ) 
        {
            $plugin = $plugins[$key];
            $plugin["folder"] = $key;
            if( !isset($plugin["parentPlugin"]) ) 
            {
                $status = !empty($hook->active_plugins) && in_array($plugin["folder"], $hook->active_plugins) ? "on" : "off";
                $cell = array(  );
                $is_installed = $hook->check_plugin_is_installed($plugin["folder"]);
                $current_data = $hook->get_plugins_data($plugin["folder"], true);
                if( $plugin["logo"] ) 
                {
                    $cell[] = "<img height=\"100\" src=\"../include/plugins/" . $plugin["folder"] . "/img/logo.png\">";
                }
                else
                {
                    $cell[] = "<img height=\"100\" src=\"../images/plugin-nologo.png\">";
                }

                $cell[] = "<h2 class=\"lightblue2\">" . htmlspecialchars_uni($plugin["name"]) . "</h2><p class=\"smallfont\">" . htmlspecialchars_uni($plugin["description"]) . "</p><p class=\"greencolor\" style=\"float:" . LANG_LEFT . ";margin:0px 5px\">" . $dimphrase["dversion"] . ": <span class=\"bluecolor2\">" . $plugin["version"] . "</span></p><p class=\"greencolor\" style=\"float:" . LANG_LEFT . ";margin:0px 5px\">" . $dimphrase["author"] . ": <span class=\"bluecolor2\">" . $plugin["author"] . "</span></p>";
                if( $is_installed ) 
                {
                    $cell[] = construct_image_link_code(is_array($hook->active_plugins) && array_key_exists($plugin["folder"], $hook->active_plugins) ? "switch lightblue3" : "switch redcolor", "plugins.php?action=" . (is_array($hook->active_plugins) && array_key_exists($plugin["folder"], $hook->active_plugins) ? "deactivate" : "activate") . "&folder=" . $plugin["folder"], "", is_array($hook->active_plugins) && array_key_exists($plugin["folder"], $hook->active_plugins) ? $dimphrase["deactivate"] : $dimphrase["activate"]);
                    $cell[] = construct_image_link_code("cycle orangecolor", "plugins.php?action=upgrade&id=" . $is_installed, "", $dimphrase["upgrade"]);
                    $cell[] = construct_image_link_code("remove2 redcolor", "plugins.php?action=remv&id=" . $is_installed, "", $dimphrase["uninstall"]);
                }
                else
                {
                    $cell[] = construct_image_code("switch graycolor", "");
                    $cell[] = construct_image_link_code("download3 greencolor", "plugins.php?action=install&folder=" . $plugin["folder"], "", $dimphrase["install"]);
                    $cell[] = construct_image_code("cross3 graycolor", "");
                }

                print_cells_row($cell, 0, "", -1, "");
                unset($parentimg);
            }

            if( $is_installed ) 
            {
                $hook->print_child_plugin_data($plugin["folder"], 0, $hook->check_plugin_is_installed($plugin["folder"]));
            }

        }

        $hook->print_child_plugin_data(false);
    }
    print_table_footer();
    echo "</div>";
    $plstatuses = array( "Active" => "success", "Pending" => "info", "Suspended" => "danger", "Cancelled" => "warning", "Terminated" => "warning" );
    echo "<div role=\"tabpanel\" class=\"tab-pane fade\" id=\"available\" aria-labelledby=\"available-tab\"><br />";
    foreach( (array) $license["plugins"] as $key => $plugin ) 
    {
        if( (array_key_exists($key, $plugins) || array_key_exists($key, $license["plugins"])) && !$hook->check_plugin_is_installed($plugins[$key]["folder"]) ) 
        {
            if( $plugin["version"] == $plugins[$key]["version"] ) 
            {
                $link = "plugins.php?action=install&folder=" . $key;
            }
            else
            {
                $link = "plugins.php?action=installstoreplugin&folder=" . $key . "&pluginid=" . $plugin["pluginid"] . "&version=" . $plugin["version"];
            }

            echo "<div style=\"margin-" . LANG_LEFT . ":8px;width: 250px;float: " . LANG_LEFT . ";\"class=\"list-group\">\r\n                <a href=\"#\" class=\"unclickable list-group-item active\" style=\"background-color: #354159;border-color: #354159;\">" . $plugin["name"] . "</a>\r\n                <a href=\"#\" class=\"available unclickable list-group-item\"><img src=\"../include/plugins/logos/" . $plugin["pluginid"] . "_important.png\"></a>\r\n                <a href=\"#\" class=\"unclickable list-group-item\">Licensed Version<span class=\"pull-" . LANG_RIGHT . " label label-default\">" . $plugin["version"] . "</span></a>\r\n                <a href=\"#\" class=\"unclickable list-group-item\">Last Version<span class=\"pull-" . LANG_RIGHT . " label label-" . iif(is_newer_version($plugin["lastversion"], $plugin["version"]), "success", "default") . "\">" . $plugin["lastversion"] . "</span></a>\r\n                <a onclick=\"DIM_showinline('available','" . $link . "',this); return false;\" href=\"#\" class=\"list-group-item\"><span class=\"tcen\"><input class=\"button\" type=\"submit\" value=\"" . $dimphrase["install"] . "\" name=\"submit\"></span></a>\r\n                </div>";
        }

    }
    echo "<div class=\"clearfix\"></div></div><div role=\"tabpanel\" class=\"tab-pane fade\" id=\"updates\" aria-labelledby=\"updates-tab\"><br />";
    foreach( (array) $license["plugins"] as $key => $plugin ) 
    {
        if( array_key_exists($key, $plugins) && $hook->check_plugin_is_installed($plugins[$key]["folder"]) && is_newer_version($plugin["version"], $plugins[$key]["version"]) ) 
        {
            echo "<div style=\"margin-" . LANG_LEFT . ":8px;width: 250px;float: " . LANG_LEFT . ";\"class=\"list-group\">\r\n                <a href=\"#\" class=\"unclickable list-group-item active\" style=\"background-color: #354159;border-color: #354159;\">" . $plugin["name"] . "</a>\r\n                <a href=\"#\" class=\"available unclickable list-group-item\"><img src=\"../include/plugins/logos/" . $plugin["pluginid"] . "_important.png\"></a>\r\n                <a href=\"#\" class=\"unclickable list-group-item\">Licensed Version<span class=\"pull-" . LANG_RIGHT . " label label-default\">" . $plugin["version"] . "</span></a>\r\n                <a href=\"#\" class=\"unclickable list-group-item\">Current Version<span class=\"pull-" . LANG_RIGHT . " label label-default\">" . $plugins[$key]["version"] . "</span></a>\r\n                <a href=\"#\" class=\"unclickable list-group-item\">Last Version<span class=\"pull-" . LANG_RIGHT . " label label-" . iif(is_newer_version($plugin["lastversion"], $plugin["version"]), "success", "default") . "\">" . $plugin["lastversion"] . "</span></a>\r\n                <a onclick=\"DIM_showinline('updates','plugins.php?action=upgradestoreplugin&folder=" . $key . "&pluginid=" . $plugin["pluginid"] . "&version=" . $plugin["version"] . "',this); return false;\" href=\"#\" class=\"list-group-item\"><span class=\"tcen\"><input class=\"button\" type=\"submit\" value=\"" . $dimphrase["upgrade"] . "\" name=\"submit\"></span></a>\r\n                </div>";
        }
        else
        {
            if( array_key_exists($key, $plugins) && is_newer_version($plugin["lastversion"], $plugins[$key]["version"]) ) 
            {
                echo "<div style=\"margin-" . LANG_LEFT . ":8px;width: 250px;float: " . LANG_LEFT . ";\"class=\"list-group\">\r\n                <a href=\"#\" class=\"unclickable list-group-item active\" style=\"background-color: #354159;border-color: #354159;\">" . $plugin["name"] . "</a>\r\n                <a href=\"#\" class=\"available unclickable list-group-item\"><img src=\"../include/plugins/logos/" . $plugin["pluginid"] . "_important.png\"></a>\r\n                <a href=\"#\" class=\"unclickable list-group-item\">Licensed Version<span class=\"pull-" . LANG_RIGHT . " label label-default\">" . $plugin["version"] . "</span></a>\r\n                <a href=\"#\" class=\"unclickable list-group-item\">Current Version<span class=\"pull-" . LANG_RIGHT . " label label-default\">" . $plugins[$key]["version"] . "</span></a>\r\n                <a href=\"#\" class=\"unclickable list-group-item\">Last Version<span class=\"pull-" . LANG_RIGHT . " label label-" . iif(is_newer_version($plugin["lastversion"], $plugin["version"]), "success", "default") . "\">" . $plugin["lastversion"] . "</span></a>\r\n                <a href=\"" . STORE_URL . $storemodule . "/s/" . $plugin["pluginid"] . "\" target=\"_blank\" class=\"list-group-item\"><span class=\"tcen\"><input class=\"button\" type=\"submit\" value=\"" . $dimphrase["view"] . "\" name=\"submit\"></span></a>\r\n                </div>";
            }

        }

    }
    echo "<div class=\"clearfix\"></div></div><div role=\"tabpanel\" class=\"tab-pane fade\" id=\"styles\" aria-labelledby=\"styles-tab\"><br />";
    if( is_array($license["styles"]) && !empty($license["styles"]) ) 
    {
        foreach( (array) $license["styles"] as $key => $dimstyle ) 
        {
            if( !file_exists(DIR . "/styles/" . $key . "/options/style_data.php") ) 
            {
                echo "<div style=\"margin-" . LANG_LEFT . ":8px;width: 250px;float: " . LANG_LEFT . ";\"class=\"list-group\">\r\n                <a href=\"#\" class=\"unclickable list-group-item active\" style=\"background-color: #354159;border-color: #354159;\">" . $dimstyle["name"] . "</a>\r\n                <a href=\"#\" class=\"available unclickable list-group-item\"><img src=\"../include/plugins/logos/" . $dimstyle["pluginid"] . "_important.png\"></a>\r\n                <a href=\"#\" class=\"unclickable list-group-item\">Licensed Version<span class=\"pull-" . LANG_RIGHT . " label label-default\">" . $dimstyle["version"] . "</span></a>\r\n                <a onclick=\"DIM_showinline('styles','plugins.php?action=installstorestyle&folder=" . $key . "&pluginid=" . $dimstyle["pluginid"] . "&version=" . $dimstyle["version"] . "',this); return false;\" href=\"#\" class=\"list-group-item\"><span class=\"tcen\"><input class=\"button\" type=\"submit\" value=\"" . $dimphrase["install"] . "\" name=\"submit\"></span></a>\r\n                </div>";
            }

        }
    }

    echo "<div class=\"clearfix\"></div></div><div role=\"tabpanel\" class=\"tab-pane fade\" id=\"latestproducts\" aria-labelledby=\"latestproducts-tab\"><br /><div id=\"products\"></div><div class=\"clearfix\"></div></div>\r\n    </div>\r\n  </div>\r\n<script>\r\n\$(\".unclickable,#latestproducts-tab\").click(function (e) {\r\ne.preventDefault();\r\n});\r\n</script>\r\n";
    print_cp_footer();
}
else
{
    if( $dimofinf->GPC["action"] == "install" && $dimofinf->GPC["folder"] != "" ) 
    {
        $plugins = $hook->get_plugins_data();
        if( array_key_exists($dimofinf->GPC["folder"], $plugins) ) 
        {
            $check_if_plugin_already_installed_before = $hook->check_plugin_is_installed($plugins[$dimofinf->GPC["folder"]]["folder"]);
            if( !$check_if_plugin_already_installed_before ) 
            {
                if( isset($plugins[$dimofinf->GPC["folder"]]["parentPlugin"]) && !$hook->check_plugin_is_installed($plugins[$dimofinf->GPC["folder"]]["parentPlugin"]) ) 
                {
                    print_error_message("plugin_parent_error", $plugins[$dimofinf->GPC["folder"]]["parentPlugin"]);
                }

                $return = array(  );
                if( !file_exists(PLUGINS_FOLDER . $plugins[$dimofinf->GPC["folder"]]["folder"] . "/plugin_data.php") ) 
                {
                    print_error_message("plugindatafile_not_found");
                }
                else
                {
                    if( array_key_exists($dimofinf->GPC["folder"], $license["plugins"]) ) 
                    {
                        foreach( $license["plugins"] as $pkey => $pvalue ) 
                        {
                            if( $plugins[$dimofinf->GPC["folder"]]["folder"] == $pkey ) 
                            {
                                if( $pvalue["status"] != "Active" ) 
                                {
                                    print_error_message("plugin_could_not_be_activated", $plugins[$dimofinf->GPC["folder"]]["folder"], construct_phrase($dimphrase["license_is"], $pvalue["status"]));
                                }

                                if( $pvalue["version"] && is_newer_version($plugins[$dimofinf->GPC["folder"]]["version"], $pvalue["version"]) ) 
                                {
                                    print_error_message("plugin_could_not_be_activated", $plugins[$dimofinf->GPC["folder"]]["folder"], construct_phrase($dimphrase["version_is"], $plugins[$dimofinf->GPC["folder"]]["version"], $pvalue["version"]));
                                }

                            }

                        }
                    }
                    else
                    {
                        print_error_message("plugin_could_not_be_activated", $plugins[$dimofinf->GPC["folder"]]["folder"], construct_phrase($dimphrase["license_is"], "Not Licensed"));
                    }

                    require_once(PLUGINS_FOLDER . $plugins[$dimofinf->GPC["folder"]]["folder"] . "/plugin_data.php");
                    if( !function_exists($plugins[$dimofinf->GPC["folder"]]["folder"] . "_install") ) 
                    {
                        print_error_message("pluginfunctioninstall_not_found");
                    }
                    else
                    {
                        if( $plugins[$dimofinf->GPC["folder"]]["is_module"] ) 
                        {
                            $hook->uninstall_plugin_as_module($plugins[$dimofinf->GPC["folder"]]);
                        }

                        $plugins[$dimofinf->GPC["folder"]]["description"] = $dimofinf->db->escape_string($plugins[$dimofinf->GPC["folder"]]["description"]);
                        $plugin_data = serialize($plugins[$dimofinf->GPC["folder"]]);
                        $dimofinf->db->query("INSERT INTO " . TABLE_PREFIX . "plugins (`name`,`version`,`folder`, `active`, `is_module`, `data`) \r\n                                        \t\t\t\t\t  VALUES ('" . $dimofinf->db->escape_string($plugins[$dimofinf->GPC["folder"]]["name"]) . "',\r\n                                        \t\t\t\t\t  '" . $dimofinf->db->escape_string($plugins[$dimofinf->GPC["folder"]]["version"]) . "',\r\n                                        \t\t\t\t\t  '" . $dimofinf->db->escape_string($plugins[$dimofinf->GPC["folder"]]["folder"]) . "',\r\n                                        \t\t\t\t\t  0,\r\n                                        \t\t\t\t\t  '" . $dimofinf->db->escape_string($plugins[$dimofinf->GPC["folder"]]["is_module"]) . "',\r\n                                        \t\t\t\t\t  '" . $plugin_data . "')");
                        require_once(DIR . "/include/functions_language.php");
                        $currentlang = fetch_languages_array($dimofinf->options["languageid"]);
                        if( strrpos($currentlang["languagecode"], "-") ) 
                        {
                            $currentlang["languagecode"] = explode("-", strtolower($currentlang["languagecode"]));
                            $currentlang["languagecode"] = $currentlang["languagecode"][0];
                        }

                        if( $currentlang["languagecode"] == "en" ) 
                        {
                            $currentlangid = 1;
                        }
                        else
                        {
                            $currentlangid = 2;
                        }

                        call_user_func($plugins[$dimofinf->GPC["folder"]]["folder"] . "_install", $currentlangid);
                        if( file_exists(PLUGINS_FOLDER . $plugins[$dimofinf->GPC["folder"]]["folder"] . "/xml/" . $plugins[$dimofinf->GPC["folder"]]["folder"] . "-settings.xml") ) 
                        {
                            require_once(DIR . "/include/functions_xml_impex.php");
                            $xml = read_file_contents(PLUGINS_FOLDER . $plugins[$dimofinf->GPC["folder"]]["folder"] . "/xml/" . $plugins[$dimofinf->GPC["folder"]]["folder"] . "-settings.xml");
                            xml_import_plugin_settings($xml, $plugins[$dimofinf->GPC["folder"]]["folder"]);
                            $return[] = "<span class=\"dot2 greencolor\">&#8865;</span> " . fetch_message("plugin_settings_imported");
                        }

                        $languages = fetch_languages_array();
                        $_language = false;
                        foreach( (array) $languages as $_languageid => $language ) 
                        {
                            $language["languagecode"] = explode("-", strtolower($language["languagecode"]));
                            $language["languagecode"] = "-" . $language["languagecode"][0];
                            if( $language["languagecode"] == "-en" ) 
                            {
                                $language["languagecode"] = "";
                            }

                            if( file_exists(PLUGINS_FOLDER . $plugins[$dimofinf->GPC["folder"]]["folder"] . "/xml/" . $plugins[$dimofinf->GPC["folder"]]["folder"] . $language["languagecode"] . "-language.xml") ) 
                            {
                                $xml = read_file_contents(PLUGINS_FOLDER . $plugins[$dimofinf->GPC["folder"]]["folder"] . "/xml/" . $plugins[$dimofinf->GPC["folder"]]["folder"] . $language["languagecode"] . "-language.xml");
                                xml_import_plugin_language($xml, $_languageid, $plugins[$dimofinf->GPC["folder"]]["name"], false, $plugins[$dimofinf->GPC["folder"]]["folder"] . "-language", $plugins[$dimofinf->GPC["folder"]]["folder"]);
                                $_language = true;
                            }
                            else
                            {
                                if( file_exists(PLUGINS_FOLDER . $plugins[$dimofinf->GPC["folder"]]["folder"] . "/xml/" . $plugins[$dimofinf->GPC["folder"]]["folder"] . "-language.xml") ) 
                                {
                                    $xml = read_file_contents(PLUGINS_FOLDER . $plugins[$dimofinf->GPC["folder"]]["folder"] . "/xml/" . $plugins[$dimofinf->GPC["folder"]]["folder"] . "-language.xml");
                                    xml_import_plugin_language($xml, $_languageid, $plugins[$dimofinf->GPC["folder"]]["name"], false, $plugins[$dimofinf->GPC["folder"]]["folder"] . "-language", $plugins[$dimofinf->GPC["folder"]]["folder"]);
                                    $_language = true;
                                }

                            }

                            unset($xml);
                        }
                        if( $_language ) 
                        {
                            $return[] = "<span class=\"dot2 greencolor\">&#8865;</span> " . fetch_message("plugin_language_imported");
                        }

                        require_once(DIR . "/include/class_bitfield.php");
                        $myobj =& DIM_Bf_Builder::init();
                        $myobj->datastore = $myobj->build_plugins(true, false, $plugins[$dimofinf->GPC["folder"]]["folder"], true);
                        if( $myobj->datastore !== false ) 
                        {
                            $myobj->bf_data = $myobj->datastore;
                            $groupinfo = array(  );
                            if( count($myobj->bf_data["ugp"]) ) 
                            {
                                foreach( (array) $myobj->bf_data["ugp"] as $grouptitle => $perms ) 
                                {
                                    foreach( $dimofinf->usergroupcache as $x => $v ) 
                                    {
                                        $groupinfo[$x][$grouptitle] = 0;
                                    }
                                    foreach( (array) $perms as $permtitle => $permvalue ) 
                                    {
                                        if( empty($permvalue["group"]) ) 
                                        {
                                            continue;
                                        }

                                        if( !empty($permvalue["install"]) ) 
                                        {
                                            foreach( (array) $permvalue["install"] as $gid ) 
                                            {
                                                $groupinfo[$gid][$grouptitle] += $permvalue["value"];
                                            }
                                        }

                                    }
                                    $chekc_if_column_already_exists = $dimofinf->db->query_first_slave("SHOW COLUMNS FROM `" . TABLE_PREFIX . "usergroup` LIKE '" . $dimofinf->db->escape_string($grouptitle) . "'");
                                    if( !$chekc_if_column_already_exists ) 
                                    {
                                        $dimofinf->db->query_write("ALTER TABLE " . TABLE_PREFIX . "usergroup ADD COLUMN " . $dimofinf->db->escape_string($grouptitle) . " BIGINT(20) UNSIGNED NOT NULL DEFAULT '0'");
                                    }

                                    $dimofinf->usergroupcache = build_usergroup_datastore(true);
                                    foreach( (array) $dimofinf->usergroupcache as $usergroup ) 
                                    {
                                        $_perm = array(  );
                                        foreach( (array) $groupinfo[$usergroup["usergroupid"]] as $kkk => $vvv ) 
                                        {
                                            if( $groupinfo[$usergroup["usergroupid"]][$kkk] != 0 ) 
                                            {
                                                $_perm[] = $dimofinf->db->escape_string($kkk) . " = '" . (int) $vvv . "'";
                                            }

                                        }
                                        if( count($_perm) ) 
                                        {
                                            $_perm = implode(",", $_perm);
                                            $dimofinf->db->query_write("UPDATE " . TABLE_PREFIX . "usergroup SET " . $_perm . " WHERE usergroupid=" . (int) $usergroup["usergroupid"] . "");
                                        }

                                    }
                                }
                                $return[] = "<span class=\"dot2 greencolor\">&#8865;</span> " . fetch_message("plugin_perm_added");
                            }

                            $return[] = "<span class=\"dot2 greencolor\">&#8865;</span> " . fetch_message("plugin_usrgrpprm_imported");
                            $myobj->save($dimofinf->db);
                        }

                        DIM_Bf_Builder::build(false);
                        $myobj =& DIM_Bf_Builder::init();
                        $myobj->save($dimofinf->db);
                        $message = implode("<br />", $return);
                        $message = !empty($message) ? "<div style=\"font-weight:normal;text-align:" . LANG_LEFT . ";float:" . LANG_LEFT . ";\">" . $message . "</span><br /><br />" : $message;
                        build_options();
                        build_usergroup_datastore();
                        build_plugins_datastore();
                        build_module_sections();
                        $_REQUEST["reffurl"] = "plugins.php?action=list";
                        $logdata = array( "Plugin" => $dimofinf->GPC["folder"] );
                        log_action($logdata);
                        success_message($message . fetch_message("plugin_installed"));
                    }

                }

            }
            else
            {
                print_error_message("plugin_already_installed");
            }

        }
        else
        {
            print_error_message("plugin_not_found");
        }

    }
    else
    {
        if( $dimofinf->GPC["action"] == "remv" && $dimofinf->GPC["id"] != "" ) 
        {
            print_cp_header($dimphrase["menu_plugins_manager"]);
            print_delete_confirmation("plugins", $dimofinf->GPC["id"], "plugins", "doremv", "plugins", "", "", "name", false);
            print_cp_footer();
        }
        else
        {
            if( $dimofinf->GPC["action"] == "upgrade" && $dimofinf->GPC["id"] != "" ) 
            {
                print_cp_header($dimphrase["menu_plugins_manager"]);
                print_delete_confirmation("plugins", $dimofinf->GPC["id"], "plugins", "doupgrade", "plugins", "", "", "name", false, true);
                print_cp_footer();
            }
            else
            {
                if( $dimofinf->GPC["action"] == "doremv" ) 
                {
                    $installedpluginrow = $dimofinf->db->query_first_slave("SELECT * FROM " . TABLE_PREFIX . "plugins WHERE id= '" . $dimofinf->GPC["id"] . "'");
                    $plugins = $hook->get_plugins_data();
                    foreach( $plugins as $kplugin => $vplugin ) 
                    {
                        if( $kplugin == $installedpluginrow["folder"] ) 
                        {
                            $arrPlugins[$kplugin] = $vplugin;
                        }
                        else
                        {
                            if( $vplugin["parentPlugin"] == $installedpluginrow["folder"] ) 
                            {
                                $arrPlugins[$kplugin] = $vplugin;
                            }

                        }

                    }
                    unset($plugins);
                    unset($kplugin);
                    unset($vplugin);
                    $plugins = $arrPlugins;
                    if( array_key_exists($installedpluginrow["folder"], $plugins) ) 
                    {
                        foreach( $plugins as $kmodules => $vmodules ) 
                        {
                            $return = array(  );
                            if( !file_exists(PLUGINS_FOLDER . $kmodules . "/plugin_data.php") ) 
                            {
                                print_error_message("plugindatafile_not_found");
                            }
                            else
                            {
                                require_once(PLUGINS_FOLDER . $kmodules . "/plugin_data.php");
                                if( !function_exists($kmodules . "_uninstall") ) 
                                {
                                    print_error_message("pluginfunctionuninstall_not_found");
                                }
                                else
                                {
                                    if( $plugins[$kmodules]["is_module"] ) 
                                    {
                                        $hook->uninstall_plugin_as_module($plugins[$kmodules]);
                                    }

                                    call_user_func($kmodules . "_uninstall");
                                    $dimofinf->db->query("DELETE FROM " . TABLE_PREFIX . "setting WHERE product = '" . $dimofinf->db->escape_string($kmodules) . "'");
                                    $dimofinf->db->query("DELETE FROM " . TABLE_PREFIX . "settinggroup WHERE product = '" . $dimofinf->db->escape_string($kmodules) . "'");
                                    if( !empty($installedpluginrow["folder"]["content_table"]) ) 
                                    {
                                        $dimofinf->db->query("DELETE FROM " . TABLE_PREFIX . "productviews WHERE product = '" . $dimofinf->db->escape_string($kmodules["content_table"]) . "'");
                                    }

                                    $return[] = "<span class=\"dot2 greencolor\">&#8865;</span> " . fetch_message("plugin_settings_removed");
                                    $fetch_phrasetype_fieldname = $dimofinf->db->query_read_slave("SELECT DISTINCT(fieldname) FROM " . TABLE_PREFIX . "phrase WHERE product = '" . $dimofinf->db->escape_string($kmodules) . "'");
                                    $pt_removed = false;
                                    while( $phrasetype_row = $dimofinf->db->fetch_array($fetch_phrasetype_fieldname) ) 
                                    {
                                        if( !empty($phrasetype_row["fieldname"]) ) 
                                        {
                                            $phrasecount = $dimofinf->db->query_first_slave("SELECT COUNT(*) AS total FROM " . TABLE_PREFIX . "phrase WHERE fieldname='" . $dimofinf->db->escape_string($phrasetype_row["fieldname"]) . "' AND (product != '" . $dimofinf->db->escape_string($kmodules) . "' OR product != '' OR product != 'dimofinf')");
                                            $chekc_if_column_already_exists = $dimofinf->db->query_first_slave("SHOW COLUMNS FROM " . TABLE_PREFIX . "language LIKE 'phrasegroup_" . $dimofinf->db->escape_string($phrasetype_row["fieldname"]) . "'");
                                            if( $chekc_if_column_already_exists && $phrasecount["total"] == 0 ) 
                                            {
                                                $dimofinf->db->query_write("ALTER TABLE " . TABLE_PREFIX . "language DROP phrasegroup_" . $dimofinf->db->escape_string($phrasetype_row["fieldname"]) . "");
                                                $dimofinf->db->query("DELETE FROM " . TABLE_PREFIX . "phrasetype WHERE fieldname = '" . $dimofinf->db->escape_string($phrasetype_row["fieldname"]) . "'");
                                            }

                                            $dimofinf->db->query("DELETE FROM " . TABLE_PREFIX . "phrase WHERE product = '" . $dimofinf->db->escape_string($kmodules) . "'");
                                            $pt_removed = true;
                                        }

                                    }
                                    if( $pt_removed ) 
                                    {
                                        $return[] = "<span class=\"dot2 greencolor\">&#8865;</span> " . fetch_message("plugin_phrases_removed");
                                    }

                                    require_once(DIR . "/include/class_bitfield.php");
                                    $myobj =& DIM_Bf_Builder::init();
                                    $myobj->datastore = $myobj->build_plugins(true, false, $kmodules, true);
                                    if( $myobj->datastore !== false && @file_exists(PLUGINS_FOLDER . $kmodules . "/xml/" . $kmodules . "-bitfield.xml") ) 
                                    {
                                        require_once(DIR . "/include/class_xml.php");
                                        $xmlobj = new Dim_XML_Parser(false, PLUGINS_FOLDER . $kmodules . "/xml/" . $kmodules . "-bitfield.xml");
                                        if( $xml = $xmlobj->parse() ) 
                                        {
                                            if( is_array($xml["bitfields"]["group"]["group"][0]) ) 
                                            {
                                                foreach( $xml["bitfields"]["group"]["group"] as $bfgroup ) 
                                                {
                                                    $chekc_if_column_already_exists = $dimofinf->db->query_first_slave("SHOW COLUMNS \r\n\t                                              FROM " . TABLE_PREFIX . "usergroup \r\n\t                                              LIKE '" . $dimofinf->db->escape_string($bfgroup["name"]) . "'");
                                                    if( $chekc_if_column_already_exists ) 
                                                    {
                                                        $dimofinf->db->query_write("ALTER TABLE " . TABLE_PREFIX . "usergroup \r\n                                    \t\t\t\tDROP COLUMN " . $dimofinf->db->escape_string($bfgroup["name"]) . "");
                                                    }

                                                }
                                            }
                                            else
                                            {
                                                $chekc_if_column_already_exists = $dimofinf->db->query_first_slave("SHOW COLUMNS \r\n                                            FROM " . TABLE_PREFIX . "usergroup \r\n                                            LIKE '" . $dimofinf->db->escape_string($xml["bitfields"]["group"]["group"]["name"]) . "'");
                                                if( $chekc_if_column_already_exists ) 
                                                {
                                                    $dimofinf->db->query_write("ALTER TABLE " . TABLE_PREFIX . "usergroup \r\n                                                DROP COLUMN " . $dimofinf->db->escape_string($xml["bitfields"]["group"]["group"]["name"]) . "");
                                                }

                                            }

                                        }

                                    }

                                    if( $hook->hook_exist("plugin_removed") ) 
                                    {
                                        $hook->execute_hook("plugin_removed", array( $plugins[$kmodules] ));
                                    }

                                    $return[] = "<span class=\"dot2 greencolor\">&#8865;</span> " . fetch_message("plugin_perm_removed");
                                    $dimofinf->db->query("DELETE FROM " . TABLE_PREFIX . "plugins WHERE folder = '" . $kmodules . "'");
                                }

                                $message = implode("<br />", $return);
                                $message = !empty($message) ? "<div style=\"font-weight:normal;text-align:" . LANG_LEFT . ";float:" . LANG_LEFT . ";\">" . $message . "</span><br /><br />" : $message;
                                require_once(DIR . "/include/class_bitfield.php");
                                DIM_Bf_Builder::build(false);
                                $mobj =& DIM_Bf_Builder::init();
                                $mobj_datastore = count((array) $myobj->datastore) ? $myobj->datastore : $mobj->build_plugins(true, false, $kmodules, true);
                                if( !empty($mobj_datastore["ugp"]) ) 
                                {
                                    $mobj->save($dimofinf->db, array_keys($mobj_datastore["ugp"]));
                                }

                                build_options();
                                build_plugins_datastore();
                                build_usergroup_datastore();
                                build_module_sections();
                                $_REQUEST["reffurl"] = "plugins.php?action=list";
                                if( isset($plugins[$kmodules]["is_module"]) ) 
                                {
                                    $file = DIR . "/contents/datastore/rout.data.php";
                                    $module = $kmodules;
                                    if( file_exists($file) ) 
                                    {
                                        $tiny_route_data_store = unserialize(read_file_contents($file));
                                    }

                                    if( !isset($tiny_route_data_store) ) 
                                    {
                                        $tiny_route_data_store = array(  );
                                    }

                                    while( $key = array_search($module, $tiny_route_data_store) ) 
                                    {
                                        unset($tiny_route_data_store[$key]);
                                    }
                                    savefile($file, serialize($tiny_route_data_store));
                                }

                            }

                        }
                    }
                    else
                    {
                        print_error_message("plugin_not_found");
                    }

                    $logdata = array( "Plugin" => $installedpluginrow["folder"] );
                    log_action($logdata);
                    success_message($message . fetch_message("plugin_removed"), 1);
                }
                else
                {
                    if( $dimofinf->GPC["action"] == "doupgrade" ) 
                    {
                        $installedpluginrow = $dimofinf->db->query_first_slave("SELECT * FROM " . TABLE_PREFIX . "plugins WHERE id= '" . $dimofinf->GPC["id"] . "'");
                        $plugins = $hook->get_plugins_data();
                        if( array_key_exists($installedpluginrow["folder"], $plugins) ) 
                        {
                            $return = array(  );
                            if( !file_exists(PLUGINS_FOLDER . $installedpluginrow["folder"] . "/plugin_data.php") ) 
                            {
                                print_error_message("plugindatafile_not_found");
                            }
                            else
                            {
                                if( array_key_exists($installedpluginrow["folder"], $license["plugins"]) ) 
                                {
                                    foreach( $license["plugins"] as $pkey => $pvalue ) 
                                    {
                                        if( $plugins[$installedpluginrow["folder"]]["folder"] == $pkey ) 
                                        {
                                            if( $pvalue["status"] != "Active" ) 
                                            {
                                                print_error_message("plugin_could_not_be_activated", $plugins[$installedpluginrow["folder"]]["folder"], construct_phrase($dimphrase["license_is"], $pvalue["status"]));
                                            }

                                            if( $pvalue["version"] && is_newer_version($plugins[$installedpluginrow["folder"]]["version"], $pvalue["version"]) ) 
                                            {
                                                print_error_message("plugin_could_not_be_activated", $plugins[$installedpluginrow["folder"]]["folder"], construct_phrase($dimphrase["version_is"], $plugins[$installedpluginrow["folder"]]["version"], $pvalue["version"]));
                                            }

                                        }

                                    }
                                }
                                else
                                {
                                    print_error_message("plugin_could_not_be_activated", $plugins[$installedpluginrow["folder"]]["folder"], construct_phrase($dimphrase["license_is"], "Not Licensed"));
                                }

                                require_once(PLUGINS_FOLDER . $installedpluginrow["folder"] . "/plugin_data.php");
                                if( !function_exists($installedpluginrow["folder"] . "_upgrade") ) 
                                {
                                    print_error_message("pluginfunctionupgrade_not_found");
                                }
                                else
                                {
                                    $plugins[$installedpluginrow["folder"]]["description"] = $dimofinf->db->escape_string($plugins[$installedpluginrow["folder"]]["description"]);
                                    $plugin_data = serialize($plugins[$installedpluginrow["folder"]]);
                                    $dimofinf->db->query("UPDATE " . TABLE_PREFIX . "plugins SET \r\n                                `name` = '" . $dimofinf->db->escape_string($plugins[$installedpluginrow["folder"]]["name"]) . "' , \r\n                                `version` = '" . $dimofinf->db->escape_string($plugins[$installedpluginrow["folder"]]["version"]) . "',\r\n                                `folder` = '" . $dimofinf->db->escape_string($plugins[$installedpluginrow["folder"]]["folder"]) . "',\r\n                                `data` =  '" . $plugin_data . "' \r\n                                WHERE folder = '" . $dimofinf->db->escape_string($installedpluginrow["folder"]) . "'");
                                    build_plugins_datastore();
                                    if( file_exists(PLUGINS_FOLDER . $plugins[$installedpluginrow["folder"]]["folder"] . "/xml/" . $plugins[$installedpluginrow["folder"]]["folder"] . "-settings.xml") ) 
                                    {
                                        require_once(DIR . "/include/functions_xml_impex.php");
                                        $xml = read_file_contents(PLUGINS_FOLDER . $plugins[$installedpluginrow["folder"]]["folder"] . "/xml/" . $plugins[$installedpluginrow["folder"]]["folder"] . "-settings.xml");
                                        xml_import_plugin_settings($xml, $plugins[$installedpluginrow["folder"]]["folder"]);
                                        $return[] = "<span class=\"dot2 greencolor\">&#8865;</span> " . fetch_message("plugin_settings_imported");
                                    }

                                    require_once(DIR . "/include/functions_language.php");
                                    $languages = fetch_languages_array();
                                    $_language = false;
                                    foreach( $languages as $_languageid => $language ) 
                                    {
                                        $language["languagecode"] = explode("-", strtolower($language["languagecode"]));
                                        $language["languagecode"] = "-" . $language["languagecode"][0];
                                        if( $language["languagecode"] == "-en" ) 
                                        {
                                            $language["languagecode"] = "";
                                        }

                                        if( file_exists(PLUGINS_FOLDER . $plugins[$installedpluginrow["folder"]]["folder"] . "/xml/" . $plugins[$installedpluginrow["folder"]]["folder"] . $language["languagecode"] . "-language.xml") ) 
                                        {
                                            $xml = read_file_contents(PLUGINS_FOLDER . $plugins[$installedpluginrow["folder"]]["folder"] . "/xml/" . $plugins[$installedpluginrow["folder"]]["folder"] . $language["languagecode"] . "-language.xml");
                                            xml_import_plugin_language($xml, $_languageid, $plugins[$installedpluginrow["folder"]]["name"], false, $plugins[$installedpluginrow["folder"]]["folder"] . "-language", $plugins[$installedpluginrow["folder"]]["folder"]);
                                            $_language = true;
                                        }
                                        else
                                        {
                                            if( file_exists(PLUGINS_FOLDER . $plugins[$installedpluginrow["folder"]]["folder"] . "/xml/" . $plugins[$installedpluginrow["folder"]]["folder"] . "-language.xml") ) 
                                            {
                                                $xml = read_file_contents(PLUGINS_FOLDER . $plugins[$installedpluginrow["folder"]]["folder"] . "/xml/" . $plugins[$installedpluginrow["folder"]]["folder"] . "-language.xml");
                                                xml_import_plugin_language($xml, $_languageid, $plugins[$installedpluginrow["folder"]]["name"], false, $plugins[$installedpluginrow["folder"]]["folder"] . "-language", $plugins[$installedpluginrow["folder"]]["folder"]);
                                                $_language = true;
                                            }

                                        }

                                        unset($xml);
                                    }
                                    if( $_language ) 
                                    {
                                        $return[] = "<span class=\"dot2 greencolor\">&#8865;</span> " . fetch_message("plugin_language_imported");
                                    }

                                    require_once(DIR . "/include/class_bitfield.php");
                                    $myobj =& DIM_Bf_Builder::init();
                                    $myobj->datastore = $myobj->build_plugins(true, false, $plugins[$installedpluginrow["folder"]]["folder"], true);
                                    if( $myobj->datastore !== false ) 
                                    {
                                        $myobj->bf_data = $myobj->datastore;
                                        $groupinfo = array(  );
                                        if( count($myobj->bf_data["ugp"]) ) 
                                        {
                                            foreach( (array) $myobj->bf_data["ugp"] as $grouptitle => $perms ) 
                                            {
                                                foreach( $dimofinf->usergroupcache as $x => $v ) 
                                                {
                                                    $groupinfo[$x][$grouptitle] = 0;
                                                }
                                                foreach( (array) $perms as $permtitle => $permvalue ) 
                                                {
                                                    if( empty($permvalue["group"]) ) 
                                                    {
                                                        continue;
                                                    }

                                                    if( !empty($permvalue["install"]) ) 
                                                    {
                                                        foreach( (array) $permvalue["install"] as $gid ) 
                                                        {
                                                            if( !array_key_exists($gid, $dimofinf->usergroupcache) ) 
                                                            {
                                                                $groupinfo[$gid][$grouptitle] += $permvalue["value"];
                                                            }

                                                        }
                                                    }

                                                }
                                                foreach( $dimofinf->usergroupcache as $x => $v ) 
                                                {
                                                    $groupinfo[$x][$grouptitle] = $groupinfo[$x][$grouptitle] ? $groupinfo[$x][$grouptitle] : $v[$grouptitle];
                                                }
                                                $chekc_if_column_already_exists = $dimofinf->db->query_first_slave("SHOW COLUMNS FROM `" . TABLE_PREFIX . "usergroup` LIKE '" . $dimofinf->db->escape_string($grouptitle) . "'");
                                                if( !$chekc_if_column_already_exists ) 
                                                {
                                                    $dimofinf->db->query_write("ALTER TABLE " . TABLE_PREFIX . "usergroup ADD COLUMN " . $dimofinf->db->escape_string($grouptitle) . " BIGINT(20) UNSIGNED NOT NULL DEFAULT '0'");
                                                }

                                                $dimofinf->usergroupcache = build_usergroup_datastore(true);
                                                foreach( (array) $dimofinf->usergroupcache as $usergroup ) 
                                                {
                                                    $_perm = array(  );
                                                    foreach( (array) $groupinfo[$usergroup["usergroupid"]] as $kkk => $vvv ) 
                                                    {
                                                        if( $groupinfo[$usergroup["usergroupid"]][$kkk] != 0 ) 
                                                        {
                                                            $_perm[] = $dimofinf->db->escape_string($kkk) . " = '" . (int) $vvv . "'";
                                                        }

                                                    }
                                                    if( count($_perm) ) 
                                                    {
                                                        $_perm = implode(",", $_perm);
                                                        $dimofinf->db->query_write("UPDATE " . TABLE_PREFIX . "usergroup SET " . $_perm . " WHERE usergroupid=" . (int) $usergroup["usergroupid"] . "");
                                                        build_usergroup_datastore(false);
                                                    }

                                                }
                                            }
                                            $return[] = "<span class=\"dot2 greencolor\">&#8865;</span> " . fetch_message("plugin_perm_added");
                                        }

                                        $return[] = "<span class=\"dot2 greencolor\">&#8865;</span> " . fetch_message("plugin_usrgrpprm_imported");
                                        $myobj->save($dimofinf->db);
                                    }

                                    call_user_func($plugins[$installedpluginrow["folder"]]["folder"] . "_upgrade");
                                    $message = implode("<br />", $return);
                                    $message = !empty($message) ? "<div style=\"font-weight:normal;text-align:" . LANG_LEFT . ";float:" . LANG_LEFT . ";\">" . $message . "</div><br /><br />" : $message;
                                    require_once(DIR . "/include/class_bitfield.php");
                                    DIM_Bf_Builder::build(false);
                                    $myobj =& DIM_Bf_Builder::init();
                                    $myobj->save($dimofinf->db);
                                    build_options();
                                    build_plugins_datastore();
                                    build_module_sections();
                                    $_REQUEST["reffurl"] = "plugins.php?action=list";
                                    $logdata = array( "Plugin" => $installedpluginrow["folder"] );
                                    log_action($logdata);
                                    success_message($message . "<br /><br />" . fetch_message("plugin_upgraded"), 1);
                                }

                            }

                        }
                        else
                        {
                            print_error_message("plugin_not_found");
                        }

                    }
                    else
                    {
                        if( $dimofinf->GPC["action"] == "activate" && $dimofinf->GPC["folder"] != "" ) 
                        {
                            $plugins = $hook->get_plugins_data();
                            if( is_array($plugins) && array_key_exists($dimofinf->GPC["folder"], $plugins) ) 
                            {
                                $check_if_plugin_already_installed = $hook->check_plugin_is_installed($plugins[$dimofinf->GPC["folder"]]["folder"]);
                                if( $check_if_plugin_already_installed ) 
                                {
                                    if( array_key_exists($dimofinf->GPC["folder"], $license["plugins"]) ) 
                                    {
                                        foreach( (array) $license["plugins"] as $pkey => $pvalue ) 
                                        {
                                            if( $plugins[$dimofinf->GPC["folder"]]["folder"] == $pkey ) 
                                            {
                                                if( $pvalue["status"] != "Active" ) 
                                                {
                                                    print_error_message("plugin_could_not_be_activated", $plugins[$dimofinf->GPC["folder"]]["folder"], construct_phrase($dimphrase["license_is"], $pvalue["status"]));
                                                }

                                                if( $pvalue["version"] && is_newer_version($plugins[$dimofinf->GPC["folder"]]["version"], $pvalue["version"]) ) 
                                                {
                                                    print_error_message("plugin_could_not_be_activated", $plugins[$dimofinf->GPC["folder"]]["folder"], construct_phrase($dimphrase["version_is"], $plugins[$dimofinf->GPC["folder"]]["version"], $pvalue["version"]));
                                                }

                                            }

                                        }
                                    }
                                    else
                                    {
                                        print_error_message("plugin_could_not_be_activated", $plugins[$dimofinf->GPC["folder"]]["folder"], construct_phrase($dimphrase["license_is"], "Not Licensed"));
                                    }

                                    $check_if_plugin_already_activated = $hook->check_plugin_is_activated($plugins[$dimofinf->GPC["folder"]]["folder"]);
                                    if( $check_if_plugin_already_activated === false ) 
                                    {
                                        require_once(PLUGINS_FOLDER . $plugins[$dimofinf->GPC["folder"]]["folder"] . "/plugin_data.php");
                                        if( !function_exists($plugins[$dimofinf->GPC["folder"]]["folder"] . "_activate") ) 
                                        {
                                            print_error_message("pluginfunctionactivate_not_found");
                                        }

                                        if( $plugins[$dimofinf->GPC["folder"]]["is_module"] ) 
                                        {
                                            $hook->uninstall_plugin_as_module($plugins[$dimofinf->GPC["folder"]]);
                                            $hook->install_plugin_as_module($plugins[$dimofinf->GPC["folder"]]);
                                        }

                                        call_user_func($plugins[$dimofinf->GPC["folder"]]["folder"] . "_activate");
                                        if( empty($hook->active_plugins) || is_array($hook->active_plugins) && !array_key_exists($dimofinf->GPC["folder"], $hook->active_plugins) ) 
                                        {
                                            $dimofinf->db->query("UPDATE " . TABLE_PREFIX . "plugins SET active='1' WHERE folder= '" . $dimofinf->GPC["folder"] . "'");
                                            build_plugins_datastore();
                                        }

                                        $dimofinf->pluginscache[] = $plugins[$dimofinf->GPC["folder"]];
                                        require_once(DIR . "/include/class_bitfield.php");
                                        DIM_Bf_Builder::build(false);
                                        $myobj =& DIM_Bf_Builder::init();
                                        $myobj->save($dimofinf->db);
                                        build_options();
                                        build_usergroup_datastore();
                                        build_module_sections();
                                        $_REQUEST["reffurl"] = "plugins.php?action=list";
                                        success_message($message . fetch_message("plugin_activated"), 1);
                                    }
                                    else
                                    {
                                        $logdata = array( "Plugin" => $dimofinf->GPC["folder"] );
                                        log_action($logdata);
                                        print_error_message("plugin_already_activated");
                                    }

                                }
                                else
                                {
                                    print_error_message("plugin_is_not_installed");
                                }

                            }
                            else
                            {
                                print_error_message("plugin_not_found");
                            }

                        }
                        else
                        {
                            if( $dimofinf->GPC["action"] == "deactivate" && $dimofinf->GPC["folder"] != "" ) 
                            {
                                $success = false;
                                $error = false;
                                $msg = array(  );
                                $installedpluginrow = $dimofinf->db->query_first_slave("SELECT * FROM " . TABLE_PREFIX . "plugins WHERE folder= '" . $dimofinf->GPC["folder"] . "'");
                                $plugins = $hook->get_plugins_data();
                                foreach( $plugins as $kplugin => $vplugin ) 
                                {
                                    if( $kplugin == $installedpluginrow["folder"] ) 
                                    {
                                        $arrPlugins[$kplugin] = $vplugin;
                                    }
                                    else
                                    {
                                        if( $vplugin["parentPlugin"] == $installedpluginrow["folder"] ) 
                                        {
                                            $arrPlugins[$kplugin] = $vplugin;
                                        }

                                    }

                                }
                                if( empty($hook->active_plugins) || is_array($plugins) && array_key_exists($installedpluginrow["folder"], $plugins) ) 
                                {
                                    foreach( $arrPlugins as $kmodules => $vmodules ) 
                                    {
                                        $check_if_plugin_already_installed = $hook->check_plugin_is_installed($plugins[$kmodules]["folder"]);
                                        if( $check_if_plugin_already_installed ) 
                                        {
                                            $check_if_plugin_already_activated = $hook->check_plugin_is_activated($plugins[$kmodules]["folder"]);
                                            if( $check_if_plugin_already_activated === true ) 
                                            {
                                                require_once(PLUGINS_FOLDER . $plugins[$kmodules]["folder"] . "/plugin_data.php");
                                                if( !function_exists($plugins[$kmodules]["folder"] . "_deactivate") ) 
                                                {
                                                    $error = true;
                                                    $msg["e"] = "pluginfunctiondeactivate_not_found";
                                                }

                                                if( $plugins[$kmodules]["is_module"] ) 
                                                {
                                                    $hook->uninstall_plugin_as_module($plugins[$kmodules]);
                                                }

                                                call_user_func($plugins[$kmodules]["folder"] . "_deactivate");
                                                if( is_array($hook->active_plugins) && array_key_exists($plugins[$kmodules]["folder"], $hook->active_plugins) ) 
                                                {
                                                    $dimofinf->db->query("UPDATE " . TABLE_PREFIX . "plugins SET active='0' WHERE folder= '" . $dimofinf->db->escape_string($plugins[$kmodules]["folder"]) . "'");
                                                    build_plugins_datastore();
                                                }

                                                require_once(DIR . "/include/class_bitfield.php");
                                                DIM_Bf_Builder::build(false);
                                                $myobj =& DIM_Bf_Builder::init();
                                                $mobj_datastore = $myobj->build_plugins(true, false, $plugins[$kmodules]["folder"], true);
                                                $myobj->save($dimofinf->db, array_keys($mobj_datastore["ugp"]));
                                                build_options();
                                                build_usergroup_datastore();
                                                build_module_sections();
                                                build_plugins_datastore();
                                                $logdata = array( "Plugin" => $kmodules );
                                                log_action($logdata);
                                                $success = true;
                                                $msg["s"] = fetch_message("plugin_deactivated");
                                            }
                                            else
                                            {
                                                $logdata = array( "Plugin" => $kmodules );
                                                log_action($logdata);
                                                $error = true;
                                                $msg["e"] = "plugin_already_deactivated";
                                            }

                                        }
                                        else
                                        {
                                            print_error_message("plugin_is_not_installed");
                                        }

                                    }
                                    if( $error ) 
                                    {
                                        print_error_message($msg["e"]);
                                    }
                                    else
                                    {
                                        $_REQUEST["reffurl"] = "plugins.php?action=list";
                                        success_message($msg["s"], 1);
                                    }

                                }
                                else
                                {
                                    print_error_message("plugin_not_found");
                                }

                            }

                        }

                    }

                }

            }

        }

    }

}

exec_shut_down();

