<?php 
define("LANG_DIR", "ltr");
define("LANG_CODE", "en");
define("LANG_CHARSET", "UTF-8");
define("LANG_LEFT", "left");
define("LANG_RIGHT", "right");
$authenticate_phrases["upgrade_title"] = "Upgrade System";
$authenticate_phrases["enter_system"] = "Enter Upgrade System";
$authenticate_phrases["redirecting"] = "Redirecting...";
$upgradecore_phrases["please_login"] = "Please Log in:";
$upgradecore_phrases["php_version_too_old"] = "Dimofinf " . VERSION . " requires PHP version 4.3.3 or greater. Your PHP is version " . PHP_VERSION . ", please ask your host to upgrade.";
$upgradecore_phrases["mysql_version_too_old"] = "Dimofinf " . VERSION . " requires MySQL version 4.0.16 or greater. Your MySQL is version %1\$s, please ask your host to upgrade.";
$upgradecore_phrases["ensure_config_exists"] = "Please make sure you have created the new directory structure required by Dimofinf 3";
$upgradecore_phrases["dbname_is_mysql"] = "The database name specified in <em>include/config.php</em> as <code>\$setting['Databasename']</code> must not be <strong>mysql</strong> as this is a reserved database name.<br />Execution has been halted to prevent possible damage.";
$upgradecore_phrases["mysql_strict_mode"] = "MySQL is running in strict mode. While you may proceed, some areas of Dimofinf may not function properly. It is <em>strongly recommended</em> that you set <code>\$config['Database']['force_sql_mode']</code> to <code>true</code> in your include/config.php file!";
$upgradecore_phrases["step_x_of_y"] = " (Step %1\$d of %2\$d)";
$upgradecore_phrases["part_x_of_y"] = " (Part %1\$d To %2\$d)";
$upgradecore_phrases["unknown"] = "Unknown";
$upgradecore_phrases["file_missing"] = "File Not Found!";
$upgradecore_phrases["xml_file_versions"] = "XML File Versions:";
$upgradecore_phrases["may_take_some_time"] = "(Please be patient as some parts may take some time)";
$upgradecore_phrases["update_v_number"] = "Updating Version Number to " . VERSION . "... ";
$upgradecore_phrases["skipping_v_number_update"] = "Skipping version number update, you already have a newer version... ";
$upgradecore_phrases["done"] = "done";
$upgradecore_phrases["step_title"] = "Step %1\$d) %2\$s";
$upgradecore_phrases["batch_complete"] = "Batch complete! Click the button on the right if you are not redirected automatically.";
$upgradecore_phrases["next_batch"] = " Next Batch";
$upgradecore_phrases["next_step"] = "Next Step (%1\$d/%2\$d)";
$upgradecore_phrases["up_from_to"] = "Upgrading From (%1\$s to %2\$s)";
$upgradecore_phrases["x_ff_found"] = "We found %1\$d File/Folder that does not have writing permessions, Please recheck those colored with red, give them the writable permessions then try again.";
$upgradecore_phrases["need_config_file"] = "Please make sure you have entered the values in to config.php.new AND renamed the file to config.php.";
$upgradecore_phrases["click_button_to_proceed"] = "Click the button on the right to proceed.";
$upgradecore_phrases["page_x_of_y"] = "Page %1\$d of %2\$d";
$upgradecore_phrases["eaccelerator_too_old"] = "eAccelerator for PHP must be upgraded to 0.9.3 or newer.";
$upgradecore_phrases["apc_too_old"] = "Your server is running a version of the <a href=\"http://pecl.p" . "hp.net/package/APC/\">Alternative PHP Cache</a> (APC) that is incompatible with Dimofinf. Please upgrade APC to version 4.0.0 or newer.";
$upgradecore_phrases["mmcache_not_supported"] = "Turck MMCache has been made obsolete by eAccelerator and does not function properly with Dimofinf.";
$upgradecore_phrases["altering_x_table"] = "Altering %1\$s Table (%2\$d of %3\$d)";
$upgradecore_phrases["generic_smilies"] = "Generic Smilies";
$upgradecore_phrases["generic_awards"] = "Generic Awards";
$upgradecore_phrases["generic_specifications"] = "Generic Specification";
$upgradecore_phrases["generic_specifications"] = "Generic Avatars";
$upgradecore_phrases["generic_avatars"] = "Generic Avatars";
$upgradecore_phrases["generic_icons"] = "Generic Icons";
$upgradecore_phrases["generic_downloads"] = "Generic Downloads";
$upgradecore_phrases["cookiepath"] = "<strong>Path to Save Cookies :</strong><br><span>If you run more than one Dimofinf on the same domain</span>";
$upgradecore_phrases["smilie_smile"] = "Smile";
$upgradecore_phrases["smilie_embarrass"] = "Embarrassment";
$upgradecore_phrases["smilie_grin"] = "Big Grin";
$upgradecore_phrases["smilie_wink"] = "Wink";
$upgradecore_phrases["smilie_tongue"] = "Stick Out Tongue";
$upgradecore_phrases["smilie_cool"] = "Cool";
$upgradecore_phrases["smilie_roll"] = "Roll Eyes (Sarcastic)";
$upgradecore_phrases["smilie_mad"] = "Mad";
$upgradecore_phrases["smilie_eek"] = "EEK!";
$upgradecore_phrases["smilie_confused"] = "Confused";
$upgradecore_phrases["smilie_frown"] = "Frown";
$upgradecore_phrases["smilie_cry"] = "Cry";
$upgradecore_phrases["smilie_lool"] = "Lool";
$upgradecore_phrases["smilie_crazy"] = "Crazy";
$upgradecore_phrases["award_1"] = "award1";
$upgradecore_phrases["award_2"] = "award2";
$upgradecore_phrases["award_3"] = "award3";
$upgradecore_phrases["award_4"] = "award4";
$upgradecore_phrases["award_5"] = "award5";
$upgradecore_phrases["specification_1"] = "specification1";
$upgradecore_phrases["specification_2"] = "specification2";
$upgradecore_phrases["specification_3"] = "specification3";
$upgradecore_phrases["specification_4"] = "specification4";
$upgradecore_phrases["specification_5"] = "specification5";
$upgradecore_phrases["general_settings"] = "General Settings";
$upgradecore_phrases["dimtitle"] = "Site Title<dfn>Name of your site<br />This appears in the title of every page.</dfn>";
$upgradecore_phrases["script_url"] = "URL of your Dimofinf<dfn>Without a '<b>/</b>' (forward-slash) at the end</dfn>";
$upgradecore_phrases["domain"] = "Your Domain<dfn><b>Example:</b><br />www.dimofinf.net</dfn>";
$upgradecore_phrases["from_adress"] = "Site Email<dfn>Email address that Dimofinf will use to send email from</dfn>";
$upgradecore_phrases["setup_settings_instructions"] = "Please fill in the form below to setup basic settings.<br /> Note : after you complete the installation process you should review your \"Dimofinf Settings\" along with other modules settings and make necessary changes that suits your needs";
$upgradecore_phrases["fill_in_for_admin_account"] = "Please fill in the form below to setup an administrator account";
$upgradecore_phrases["fill_in_for_old_data"] = "Please select user in the form below to assign old data to";
$upgradecore_phrases["username"] = "User Name";
$upgradecore_phrases["password"] = "Password";
$upgradecore_phrases["confirmpassword"] = "Confirm Password";
$upgradecore_phrases["email"] = "Email Address";
$upgradecore_phrases["complete_all_data"] = "You failed to enter all data, Please correct this";
$upgradecore_phrases["password_not_match"] = "The 'Password' and 'Confirm Password' fields do not match!, Please correct this.";
$upgradecore_phrases["admin_added"] = "Administrator Added";
$upgradecore_phrases["changecurpass"] = "Change current administrator password";
$upgradecore_phrases["selectadmins"] = "Select Current administrator";
$upgradecore_phrases["usergroup_guest_title"] = "Guests";
$upgradecore_phrases["usergroup_guest_usertitle"] = "Guest";
$upgradecore_phrases["usergroup_registered_title"] = "Members";
$upgradecore_phrases["usergroup_registered_usertitle"] = "Member";
$upgradecore_phrases["usergroup_activation_title"] = "Awaiting Email Confirmation";
$upgradecore_phrases["usergroup_awmod_title"] = "Awaiting Moderation";
$upgradecore_phrases["usergroup_author_title"] = "Authors";
$upgradecore_phrases["usergroup_author_usertitle"] = "Author";
$upgradecore_phrases["usergroup_editor_title"] = "Editors";
$upgradecore_phrases["usergroup_editor_usertitle"] = "Editor";
$upgradecore_phrases["usergroup_publisher_title"] = "Publishers";
$upgradecore_phrases["usergroup_publisher_usertitle"] = "Publisher";
$upgradecore_phrases["usergroup_manager_title"] = "Managers";
$upgradecore_phrases["usergroup_manager_usertitle"] = "Manager";
$upgradecore_phrases["usergroup_admin_title"] = "Administrators";
$upgradecore_phrases["usergroup_admin_usertitle"] = "Administrator";
$upgradecore_phrases["usergroup_superadmin_title"] = "Super Administrators";
$upgradecore_phrases["usergroup_superadmin_usertitle"] = "Super Administrator";
$upgradecore_phrases["usergroup_banned_title"] = "Banned Users";
$upgradecore_phrases["usergroup_banned_usertitle"] = "Banned";
$upgradecore_phrases["pluginfunctioninstall_not_found"] = "Could not find the plugin install function.";
$upgradecore_phrases["errorplugin"] = "Install Module OR Plugin %1\$s";
$phrasetype["global"] = "GLOBAL";
$phrasetype["cpglobal"] = "Control Panel Global";
$phrasetype["error_message"] = "Control Panel Stop Message";
$phrasetype["dimofinf_messages"] = "Dimofinf Messages";
$phrasetype["language"] = "Language Tools";
$phrasetype["cphome"] = "Control Panel Home Pages";
$phrasetype["bbcode"] = "BB Code Tools";
$phrasetype["timezone"] = "Timezones";
$phrasetype["dateglobal"] = "Date Global";
$phrasetype["moderators"] = "Moderators";
$phrasetype["cpoption"] = "Control Panel Options";
$phrasetype["sql"] = "SQL Tools";
$phrasetype["diagnostic"] = "Diagnostic Tools";
$phrasetype["cron"] = "Scheduled Tasks";
$phrasetype["modules"] = "Module Names";
$phrasetype["editor"] = "Editor";
$phrasetype["album"] = "Albums";
$phrasetype["article"] = "Articles";
$phrasetype["card"] = "Cards";
$phrasetype["download"] = "Download";
$phrasetype["mobile"] = "Mobiles";
$phrasetype["news"] = "News";
$phrasetype["video"] = "Videos";
$phrasetype["voice"] = "Voices";
$phrasetype["basicmodules"] = "Basic Modules";
$phrasetype["email_subj"] = "Email Subject Text";
$phrasetype["email_body"] = "Email Body Text";
$phrasetype["cp_help"] = "Control Panel Help Text";
$phrasetype["frames"] = "Frames";
$phrasetype["countries"] = "Countries";
$phrasetype["register"] = "Register";
$phrasetype["user"] = "User Tools";
$phrasetype["usercp"] = "User Management";
$phrasetype["ugpermission"] = "User Group Permissions";
$dimphrase["retry"] = "Retry";
$dimphrase["wstatus"] = "Writable Status";
$dimphrase["content"] = "Content";
$dimphrase["file_folder"] = "File/Folder";
$dimphrase["importing_ip"] = "Importing Ip Records";
$dimphrase["importing_settings"] = "Importing Setting";
$dimphrase["importing_language"] = "Importing Language";
$dimphrase["please_wait"] = "Please Wait";
$dimphrase["language"] = "Language";
$dimphrase["master_language"] = "MASTER LANGUAGE";
$dimphrase["admin_help"] = "Admin Help";
$dimphrase["settings"] = "Settings";
$dimphrase["replacement_variables"] = "Replacement Variables";
$dimphrase["controls"] = "Controls";
$dimphrase["yes"] = "Yes";
$dimphrase["no"] = "No";
$dimphrase["retry"] = "Retry";
$dimphrase["file_not_found"] = "%1\$s doesn't appear to exist!";
$dimphrase["license_is"] = "License is <span style=\"color: #FD9800\">%1\$s</span>";
$dimphrase["version_is"] = "Plugin version %1\$s is newer than the licensed version %2\$s";
$dimphrase["plugin_not_found"] = "Could not find a plugin with this folder name <b>%1\$s</b>";
$dimphrase["plugin_could_not_be_activated"] = "Could not activat the plugin %1\$s,<br /> Reason:%2\$s";
$dimphrase["moduleinstalled"] = "Module & Plugins Installed successfully";
$dimphrase["upload_file_created_with_different_version"] = "This file was created using a different version of Dimofinf from the one you are running.<br /><br />Your version: %1\$s<br />File version: %2\$s";
$dimphrase["language_only_phrases"] = "The file you attempted to import only contains phrases and none of the settings required.\r\n\r\nYou will be unable to make a new language with this file.";
$dimphrase["language_already_exists"] = "A language called '<i>%1\$s</i>' already exists. - To use this language file, either overwrite the language called '<i>%1\$s</i>', or enter a different title on the upload form.";
$dimphrase["dimofinf_error_message"] = "<b>Dimofinf Error Message</b>";
$dimphrase["dimofinf_warning_message"] = "<b>Dimofinf Warning Message</b>";
$dimphrase["dimofinf_notice_message"] = "<b>Dimofinf Notice Message</b>";
$dimphrase["dimofinf_unknown_error_message"] = "<b>Unknown Dimofinf Error Message</b>";
$dimphrase["create_table"] = "Creating %1\$s table";
$dimphrase["create_folder"] = "Creating %1\$s folder";
$dimphrase["remove_table"] = "Removing %1\$s table";
$dimphrase["truncate_table"] = "Truncating %1\$s table";
$dimphrase["alter_table"] = "Altering %1\$s table";
$dimphrase["inserting_x_in_y"] = "Inserting %1\$s data into %2\$s";
$dimphrase["renaming_a_to_b"] = "Renaming %1\$s table to %2\$s";
$dimphrase["frenaming_a_to_b"] = "Renaming %1\$s folder to %2\$s";
$dimphrase["update_table"] = "Updating %1\$s table";
$dimphrase["upgrade_start_message"] = "This script will UPDATE your Dimofinf installation to version <b>" . VERSION . "</b> Press the 'proceed' button to proceed.";
$dimphrase["upgrade_end_message"] = "You have successfully upgraded Dimofinf CMS to v%1\$s.<br /><font size=\\\"+1\\\"><b>Press the <b>proceed</b> button to continue upgrade</b></font><br />";
$dimphrase["upgradeutf8_start_message"] = "This script will Convert your Dimofinf encoding to <b>UTF-8</b> Press the 'proceed' button to proceed.";
$dimphrase["importer_start_message"] = "This script will Import your data from other scripts to <b>Dimofinf</b> Press the 'proceed' button to proceed.<br /><span style='color:#FD9800'><b>Note:</b> This process will overwrite data in your Dimofinf database.</span>";
$dimphrase["importer_reqinfo"] = "We need some more information about other script and it's database";
$dimphrase["importer_addreqinfo"] = "We need additional information if it's available";
$dimphrase["importer_curscript"] = "Current Script";
$dimphrase["importer_dbhost"] = "Database Host";
$dimphrase["importer_dbusername"] = "Database Username";
$dimphrase["importer_dbpassword"] = "Database Password";
$dimphrase["importer_dbname"] = "Database Name";
$dimphrase["importer_dbprefix"] = "Database Table Prefix";
$dimphrase["importer_opitional"] = "Opitional";
$dimphrase["importer_percycle"] = "Per Cycle";
$dimphrase["importer_error_forum"] = "<span stlye=\"font-size:8px;\"><b>YOU MUST INSTALL THE <font color=\"#FD9800\">FORUM</font> MODULE.</b></span>";
$dimphrase["importer_error_article"] = "<span stlye=\"font-size:8px;\"><b>YOU MUST INSTALL THE <font color=\"#FD9800\">Article</font> MODULE.</b></span>";
$dimphrase["importer_error_news"] = "<span stlye=\"font-size:8px;\"><b>YOU MUST INSTALL THE <font color=\"#FD9800\">News</font> MODULE.</b></span>";
$dimphrase["importer_error_download"] = "<span stlye=\"font-size:8px;\"><b>YOU MUST INSTALL THE <font color=\"#FD9800\">Download</font> MODULE.</b></span>";
$dimphrase["importer_error_card"] = "<span stlye=\"font-size:8px;\"><b>YOU MUST INSTALL THE <font color=\"#FD9800\">Card</font> MODULE.</b></span>";
$dimphrase["importer_error_voice"] = "<span stlye=\"font-size:8px;\"><b>YOU MUST INSTALL THE <font color=\"#FD9800\">Voice</font> MODULE.</b></span>";
$dimphrase["importer_error_video"] = "<span stlye=\"font-size:8px;\"><b>YOU MUST INSTALL THE <font color=\"#FD9800\">Video</font> MODULE.</b></span>";
$dimphrase["upgrade_cont_message"] = "Is not completed steps to upgrade<br />press continue to complete it";
$dimphrase["importer_error_dynamicsections"] = "<span stlye=\"font-size:8px;\"><b>YOU MUST INSTALL THE <font color=\"#FD9800\">Dynamic Sections</font> MODULE.</b></span>";
$dimphrase["importer_error_banner"] = "<span stlye=\"font-size:8px;\"><b>YOU MUST INSTALL THE <font color=\"#FD9800\">Banner</font> MODULE.</b></span>";
$dimphrase["importer_perc"] = "<b>( %1\$d of %2\$d records )</b>";
$dimphrase["importer_part"] = "<b>Part %1\$d: </b>";
$dimphrase["importer_vb_completed"] = "You have successfully moved to Dimofinf CMS v" . VERSION . ".<br />\r\n\t\t\t\t\t\t\t\t\t\t<br />\r\n\t\t\t\t\t\t\t\t\t\t<ul>\r\n\t\t\t\t\t\t\t\t\t\t\t<li><b>Note:</b> Move your membership <u>UserGroup</u> to <u><b>Super Administrator</b></u>.</li>\r\n\t\t\t\t\t\t\t\t\t\t\t<li><span style=\"color: #FD9800\">Don't forget to recheck all permissions for users groups.</span></li>\r\n\t\t\t\t\t\t\t\t\t\t</ul>\r\n\t\t\t\t\t\t\t\t\t\t<br />\r\n\t\t\t\t\t\t\t\t\t\tWhen you have done this, Click the 'Proceed' button to continue to your Dimofinf Control Panel.";
$dimphrase["importer_vb_attachpath"] = "vBulletin Attachment Folder Path<dfn>Example: /home/example/public_html/vb/attachment</dfn>";
$dimphrase["importer_vb_avatarpath"] = "vBulletin Avatar Folder Path<dfn>Example: /home/example/public_html/vb/images/avatars</dfn>";
$dimphrase["importer_vb_propicpath"] = "vBulletin Custom Profile Pictures Folder Path<dfn>Example: /home/example/public_html/vb/customprofilepics</dfn>";
$dimphrase["importer_vb_iconpath"] = "vBulletin Icons Folder Path<dfn>Example: /home/example/public_html/vb/images/icons</dfn>";
$dimphrase["importer_vb_smilepath"] = "vBulletin Smilies Folder Path<dfn>Example: /home/example/public_html/vb/images/smilies</dfn>";
$dimphrase["importer_wp"] = "All posts will move to module article!.\r\n\t\t\t\t\t\t\t<br />\r\n\t\t\t\t\t\t\tAll pages and attachements will move to content!.\r\n\t\t\t\t\t\t\t<br />\r\n\t\t\t\t\t\t\tReplace all url to new dimofinf url.\r\n\t\t\t\t\t\t\t";
$dimphrase["importer_wp_note"] = "Make sure to copy wp_content/uploads to contents/uploads if you need!";
$dimphrase["upgrade_wrong_version"] = "<p>Your dimofinf version does not appear to match with the version for which this script was created (version <b>" . PREV_VERSION . "</b>).</p>\n<p>Please ensure that you are attempting to run the correct script.</p>\n<p>If you are sure this is the script you would like to run, <a href=\"" . THIS_SCRIPT . "?step=1\">click here</a>.</p>";
$dimphrase["upgrade_old_version"] = "<p>Your dimofinf version does not appear to match with the version for which this script was created for (version <b>" . PREV_VERSION . "</b>).</p>\n<p>Please ensure that you are attempting to run the correct script.</p>";
$dimphrase["upgrade_current_version"] = "<p>Your Dimofinf version already upgraded</p><p>Already used version 4.0.0</p>";
$dimphrase["file_missing"] = "Error, ./install/%1\$s doesn't appear to exist!";
$dimphrase["importing_file"] = "Importing %1\$s";
$dimphrase["ok"] = "Okay";
$dimphrase["cant_overwrite_non_existent_language"] = "Sorry, you can't overwrite a language that does not exist";
$dimphrase["query_took"] = "Query took %1\$s seconds to execute.";
$dimphrase["done"] = "Done";
$dimphrase["proceed"] = "Proceed";
$dimphrase["error"] = "Error";
$dimphrase["reset"] = "Reset";
$dimphrase["alter_table_step_x"] = "Altering %1\$s Table (%2\$d of %3\$d)";
$dimphrase["dimofinf_copyright"] = "<font color=\"#008080\">Dimofinf cms v" . VERSION . "</font><br />Copyright &copy;1998 - " . date("Y") . ", Dimensions Of Information Inc.";
$dimphrase["dimofinf_copyright_orig"] = $dimphrase["dimofinf_copyright"];
$dimphrase["updating_lf_complete"] = "Updating License File Complete";
$dimphrase["updating_lf_failed"] = "<font color=\"#FD9800\">Updating License File Failed</font>,<br />Please make sure that  <font color=\"#FD9800\">\"</font><font color=\"#295a4d\"><b>include/%1\$s</b></font><font color=\"#FD9800\">\"</font> exist and it has writable permession , normaly (chmod 777)";
$dimphrase["create_x_table_failed"] = "<font color=\"#FD9800\">Creating Table %1\$s Failed</font>";
$dimphrase["processing_complete_proceed"] = "Processing Complete - Proceed";
$dimphrase["xml_error_x_at_line_y"] = "XML Error: %1\$s at Line %2\$s";
$dimphrase["i2c_error"] = "%1\$s";
$dimphrase["welcome"] = "Welcome to Dimofinf";
$dimphrase["please_wait_message"] = "<font color=\"#FD9800\">The next step may take awhile. Please be patient. If the step appears to freeze, you may retry step %1\$d again.</font>";
$dimphrase["upgrade_complete"] = "You have successfully upgraded Dimofinf CMS to v" . VERSION . ".<br /><br />\r\n\t<font size=\\\"+1\\\"><b>YOU MUST DELETE THE <font color=\"#FD9800\">install</font> FOLDER BEFORE CONTINUING:</b></font><br />\r\n\t<br />\r\n\tYou can clean the database from old tables by go to <br /><b>DimCP -> Tools -> Clean Tables</b>.<br /> \r\n\tWhen you have done this, Click the 'Proceed' button to continue to your Dimofinf Control Panel.<br /><br />";
$dimphrase["upgrade_complete_click_withincoding"] = "You have successfully upgraded Dimofinf CMS to v" . VERSION . ".<br /><br />\r\n\tClick the 'Proceed' button to continue encoding UTF-8<br /><br />";
$dimphrase["upgrade_complete_next"] = "You have successfully upgraded Dimofinf CMS to v" . VERSION . "";
$dimphrase["invalid_file_specified"] = "Invalid File Specified";
$dimphrase["Dammam"] = "Dammam";
$dimphrase["Jeddah"] = "Jeddah";
$dimphrase["Makkah"] = "Makkah";
$dimphrase["Almadina"] = "Almadina";
$dimphrase["Alriyadh"] = "Alriyadh";
$dimphrase["convert_data_table"] = "Converting Data Of Table <b>%1\$s</b> (%2\$d of %3\$d records)";
$dimphrase["cont_convert_data_table"] = "Continue To Next Table <b>%1\$s</b> ?";
$dimphrase["unable_to_rename_x"] = "Unable to rename %1\$s";
$dimphrase["joomla_components"] = "Joomla Components Comment";
$dimphrase["importer_contentinfo"] = "Joomla Content";
$dimphrase["importer_contenttype"] = "Website Content";
$dimphrase["activemodules"] = "Active Modules OR Plugins";
$dimphrase["selactivemodules"] = "Select Active Modules OR Plugins";
$dimphrase["notesactivemodules"] = "Notes<br>selected will be activate plugin and others";
$dimphrase["upgrade_not_ex"] = "Version not exist in this script";
$dimphrase["no_xml_and_no_path"] = "Sorry, no XML was passed into this function and the %1\$s variable empty";
$dimphrase["plugindatafile_not_found"] = "Could not find the plugin data file.";
$dimphrase["plugindatafile_not_found"] = "Could not find the plugin install function.";
$upgrade_phrases["finalize"] = array( 1 => "Importing Dimofinf Settings", 2 => "Importing Dimofinf Language", 3 => "Importing Ip Records #1", 4 => "Importing Ip Records #2", 5 => "Importing Ip Records #3", 6 => "Importing Ip Records #4", 7 => "Importing Ip Records #5", 8 => "Importing Ip Records #6", 9 => "Importing Ip Records #7", 10 => "Importing Ip Records #8", 11 => "Importing Ip Records #9", 12 => "Importing Ip Records #10", 13 => "Upgrade to Dimofinf " . VERSION . " Complete!" );
$upgrade_phrases["upgrade_200"] = array( 1 => "Verify Configuration", 2 => "Creating And Altering", 3 => "Creating And Altering", 4 => "Creating And Altering", 5 => "Creating And Altering", 6 => "Creating And Altering", 7 => "Upgrade to Dimofinf " . VERSION . " Complete!" );
$upgrade_stepsq["upgrade_200"] = array( 1 => 1, 2 => 8, 3 => 4, 4 => 4, 5 => 8, 6 => 4, 7 => 1 );
$upgrade_phrases["upgrade_205"] = array( 1 => "Verify Configuration", 2 => "Creating And Altering", 3 => "Creating And Altering", 4 => "Drop Table" );
$upgrade_stepsq["upgrade_205"] = array( 1 => 1, 2 => 9, 3 => 9, 4 => 1 );
$upgrade_phrases["upgrade_300"] = array( 1 => "Verify Configuration", 2 => "Verify Writable Folders/Files", 3 => "Creating And Altering", 4 => "Creating And Altering", 5 => "Creating And Altering", 6 => "Creating And Inserting", 7 => "Altering Dimofinf Tables", 8 => "Altering Dimofinf Tables" );
$upgrade_stepsq["upgrade_300"] = array( 1 => 1, 2 => 1, 3 => 48, 4 => 4, 5 => 5, 6 => 5, 7 => 7, 8 => 7 );
$upgrade_stepsq["upgrade_350"] = array( 1 => 1, 2 => 1, 3 => 1, 4 => 1, 5 => 1, 6 => 1, 7 => 1, 8 => 1 );
$upgrade_phrases["upgrade_350"] = array( 1 => "Verify Configuration", 2 => "Converting Database Collation", 3 => "Creating UTF8 Upgrade Log Table", 4 => "Preparing Tables With UTF8 Charset", 5 => "Creating New Tables With UTF8 Charset", 6 => "Converting Charset And Collation", 7 => "Start Converting Data", 8 => "Converting Database Completed" );
$upgrade_phrases["upgrade_400"] = array( 1 => "Verify Configuration", 2 => "Converting Database Collation", 3 => "Creating Tables", 4 => "Altering And Updating Tables", 5 => "Converting Data", 6 => "Verify Writable Folders/Files", 7 => "Install Dimofinf Modules & Plugins", 8 => "Importing Dimofinf Settings", 9 => "Importing Dimofinf Language", 10 => "Setup Default Data", 11 => "Add Admin User", 12 => "Assign Old Data", 13 => "Upgrade to Dimofinf " . VERSION . " Complete!" );
$upgrade_stepsq["upgrade_400"] = array( 1 => 1, 2 => 1, 3 => 28, 4 => 23, 5 => 7, 6 => 1, 7 => 1, 8 => 1, 9 => 1, 10 => 1, 11 => 1, 12 => 1, 13 => 1 );
$upgrade_phrases["importer"] = array( 1 => "Verify Configuration", 2 => "Required Information", 3 => "Verifying", 4 => "Importing User Groups", 5 => "Importing Users", 6 => "Importing Avatars", 7 => "Importing BBCodes", 8 => "Importing Tags", 9 => "Importing Private Messages", 10 => "Importing Smiles", 11 => "Importing Icons", 12 => "Importing Contents", 13 => "Misc", 14 => "Finished" );
$upgradecore_phrases["welcome"] = "<p><b>Welcome to Dimofinf version 4.0.0</b></p>\r\n\t<p>You are about to perform a finalize.</p>\r\n\t<p>Clicking the <b>[Proceed]</b> button will begin the finalization process on your database.</p>\r\n\t<p>In order to prevent possible browser crashes during this script, we strongly recommend that you disable any additional toolbars you may be using on your browser, such AS the <b>Google</b> toolbar etc.</p>";
$upgradecore_phrases["finalize"] = "Dimofinf " . VERSION . " Finalize";
$upgradecore_phrases["upgrade_350"] = "Dimofinf UTF-8 Converter";
$upgradecore_phrases["upgrade_400"] = "Dimofinf " . VERSION . " Upgrader";
$upgradecore_phrases["importer"] = "Dimofinf " . VERSION . " Importer";
$upgradecore_phrases["username"] = "User Name";
$upgradecore_phrases["displayname"] = "Display Name";
$upgradecore_phrases["password"] = "Password";
$upgradecore_phrases["confirmpassword"] = "Confirm Password";
$upgradecore_phrases["email"] = "Email Address";
$upgradecore_phrases["complete_all_data"] = "You failed to enter all data, Please correct this";
$upgradecore_phrases["password_not_match"] = "The 'Password' and 'Confirm Password' fields do not match!, Please correct this.";
$upgradecore_phrases["activemodules"] = "Active Modules OR Plugins";
$upgradecore_phrases["selactivemodules"] = "Select Active Modules OR Plugins";
$upgradecore_phrases["notesactivemodules"] = "Notes<br>selected will be activate plugin and others will be removed from database";

