<?php
/*=========================================================================*\
||          ____ ___ __  __  ___  _____ ___ _   _ _____   _  _             ||
||         |  _ \_ _|  \/  |/ _ \|  ___|_ _| \ | |  ___| | || |            ||   
||         | | | | || |\/| | | | | |_   | ||  \| | |_    | || |_           ||
||         | |_| | || |  | | |_| |  _|  | || |\  |  _|   |__   _|          ||
||         |____/___|_|  |_|\___/|_|   |___|_| \_|_|        |_|            ||
||                                                                         ||
|| ================== DIMOFINF CMS IS NOT FREE SOFTWARE ================== ||
|| =================== http://www.dimofinf.net/cond.php ================== ||
|| ======================================================================= ||
\*===================== Dimensions Of Information Inc =====================*/

//	****** LICENSE KEY ******
//	This is the license key of your Dimofinf CMS.
//	Inter your license key as provided from Dimofinf Client Area.
$setting['LicenseKey'] = 'Team_ECHO_Rocks';

//	****** DATABASE TYPE ******
//	This is the type of the database server on which your Dimofinf CMS database will be located.
//	Valid options are mysql AND mysqli, for slave support add _slave.  Try to use mysqli if you are using PHP 5 AND MySQL 4.1+
// for slave options just append _slave to your preferred database type.
$setting['Databasetype'] = 'mysqli';

//	****** MASTER DATABASE SERVER NAME AND PORT ******
//	This is the hostname or IP address AND port of the database server.
//	If you are unsure of what to put here, leave the default values.
$setting['MasterServername'] = 'localhost';
$setting['MasterServerport'] = 3306;

//	****** MASTER DATABASE PERSISTENT CONNECTIONS ******
//	This option allows you to turn persistent connections to MySQL on or off.
//	The difference in performance is negligible for all but the largest sites.
//	If you are unsure what this should be, leave it off. (0 = off; 1 = on)
$setting['MasterServerusepconnect'] = 0;

//	****** DATABASE NAME ******
//	This is the name of the database WHERE your Dimofinf CMS will be located.
//	This must be created by you or your webhost.
$setting['Databasename'] = '';

//	****** MASTER DATABASE USERNAME ******
//	This is the username you use to access MySQL.
//	These must be obtained through your webhost.
$setting['MasterServerusername'] = '';

//	****** MASTER DATABASE PASSWORD ******
//	This is the password you use to access MySQL.
//	These must be obtained through your webhost.
$setting['MasterServerpassword'] = '';

//	****** SLAVE DATABASE CONFIGURATION ******
//	If you have multiple database backends, this is the information for your slave
//	server. If you are not 100% sure you need to fill in this information,
//	do not change any of the values here.
$setting['SlaveServername'] = '';
$setting['SlaveServerport'] = 3306;
$setting['SlaveServerusername'] = '';
$setting['SlaveServerpassword'] = '';
$setting['SlaveServerusepconnect'] = 0;

//	****** ADMIN CONTROL PANELS DIRECTORY ******
//	This setting allows you to change the name of the directory that the Dimofinf
//	Control panels reside in. You may wish to do this for security purposes.
//	Please note that if you change the name of the directory here, you will still
//	Need to manually change the name of the directory on the server.
$setting['Dimadmincpdir'] = 'dimcp';

//	******** FULL PATH TO Dimofinf CMSs DIRECTORY ******
//	On a few systems it may be necessary to input the full path to your Dimofinf CMSs directory
//	for Dimofinf CMS to function normally. You can ignore this setting unless Dimofinf support
//	tells you to fill this in. Do not include a trailing slash!
//	Example Unix:
//	  $setting['Dimpath'] = '/home/users/public_html/dim';
//	Example Win32:
//	  $setting['Dimpath'] = 'c:\program files\apache group\apache\htdocs\dim';
$setting['Dimpath'] = '';

//	****** TABLE PREFIX ******
//	Prefix that your Dimofinf CMS tables have in the database.
$setting['Databasetableprefix'] = '';

//	Prefix that all Dimofinf CMS cookies will have
//	Keep this short AND only use numbers AND letters, i.e. 1-9 AND a-Z
$setting['Dimcookieprefix'] = 'dim_';

//	****** UNDELETABLE / UNALTERABLE USERS ******
//	The users specified here will not be deletable or alterable from the control panel by any users.
//	To specify more than one user, separate userids with commas.
$setting['undeletableusers'] = '1';

//	****** USERS WITH ACTION LOG LISTING PERMISSION ******
//	The users specified here will be allowed to list the admin log in the control panel.
//	Users must be specified by *ID number* here. To obtain a user's ID number,
//	view their profile via the control panel. If this is a new installation, leave
//	the first user created will have a user ID of 1. Seperate each userid with a comma.
$setting['canlistactionlog'] = '1';

//	****** USERS WITH ACTION LOG DELETE PERMISSION ******
//	The users specified here will be allowed to remove ("delete") entries from the admin
//	log. See the above entry for more information on the format.
$setting['candeleteactionlog'] = '1';

//	****** MAXIMUM ACTION LOG ENTRIES ******
//	set the maximum entries that can be stored in the database.
//	new entry will be recorded and the oldest one will be deleted when reaches the number here.
$setting['maxactionlogentries'] = '1000';

// ****** DATASTORE CACHE CONFIGURATION *****
// Here you can configure different methods for caching datastore items.
// DIM_Datastore_Filecache  - to use contents/datastore/datastore_cache.php
// DIM_Datastore_eAccelerator  - to use eAccelerator
// DIM_Datastore_APC - to use APC
// DIM_Datastore_XCache - to use XCache
// DIM_Datastore_Memcached - to use a Memcache server, more configuration below
$setting['Datastoreclass'] = 'DIM_Datastore_Filecache';

// ******** DATASTORE PREFIX ******
// If you are using a PHP Caching system (APC, XCache, eAccelerator) with more
// than one SET of Dimofinf CMS installed on your host, you *may* need to use a prefix
// so that they do not try to use the same variable within the cache.
// This works in a similar manner to the database table prefix.
// $setting['Datastoreprefix'] = '';


// It is also necessary to specify the hostname or IP address AND the port the server is listening on
/*
$setting['Datastoreclass'] = 'DIM_Datastore_Memcached';
$i = 0;
// First Server
$i++;
$setting['Dim_memcacheserver'][$i] = '127.0.0.1';
$setting['Dim_memcacheport'][$i] = 11211;
$setting['Dim_memcachepersistent'][$i] = true;
$setting['Dim_memcacheweight'][$i] = 1;
$setting['Dim_memcachetimeout'][$i] = 1;
$setting['Dim_memcacheretry_interval'][$i] = 15;
*/

// ****** The following options are only needed in special cases ******


//	****** MySQLI OPTIONS *****
// When using MySQL 4.1+, MySQLi should be used to connect to the database.
// If you need to SET the default connection charset because your database
// is using a charset other than utf8, you can SET the charset here.
// If you don't SET the charset to be the same AS your database, you
// may receive collation errors.  Ignore this setting unless you
// are sure you need to use it.
$setting['Mysql_charset'] = 'utf8';

//	******** SHUTDOWNFUNC  ******
//	Shutdown function for IIS CGI with Gzip enabled
//  Setting this value to "false" disable it
//  You only need to modify this value if Dimofinf support recommends it.
$setting['Dimshutdown'] = true;

//	****** FORCE EMPTY SQL MODE ******
// If MySQL have introduced some behaviors that are
// incompatible with Dimofinf CMS. Setting this value to "true" disables those
// behaviors. You only need to modify this value if Dimofinf support recommends it.
$setting['Database_force_sql_mode'] = false;

//	Optionally, PHP can be instructed to SET connection parameters by reading from the
//	file named in 'ini_file'. Please use a full path to the file.
//	Example:
//	$setting['Mysql_ini_file'] = 'c:\program files\MySQL\MySQL Server 4.1\my.ini';
$setting['Mysql_ini_file'] = '';


//	****** ERROR REPORTING LEVEL ******
// If enabled debug , set error reporting level , for more information visit http://www.php.net/manual/en/errorfunc.constants.php
$setting['error_level'] = E_ALL & ~E_NOTICE & ~8192;

//	****** DEBUG MODE ******
// Set to true if you want to enable debugging mode
$setting['Dimdebug'] = false;

//	****** TEMPLATE DEBUG MODE ******
// Set to true if you want to enable templates debugging mode
$setting['Tpl_debug'] = false;

?>