<?php 
if( strstr($_SERVER["PHP_SELF"], "functions_admin.php") ) 
{
    Header("Location: ../index.php");
    exit();
}

if( !isset($_SERVER["HTTP_REFERER"]) ) 
{
    define("SKIP_REFERRER_CHECK", 1);
}

if( !isset($phrasegroups) || !is_array($phrasegroups) ) 
{
    $phrasegroups = array(  );
}

if( !isset($Globalassigneds) || !is_array($Globalassigneds) ) 
{
    $Globalassigneds = array(  );
}

if( !isset($Globaltemplates) || !is_array($Globaltemplates) ) 
{
    $Globaltemplates = array(  );
}

if( !isset($Globalpluginstemplates) || !is_array($Globalpluginstemplates) ) 
{
    $Globalpluginstemplates = array(  );
}

if( !isset($Globalhookmodules) || !is_array($Globalhookmodules) ) 
{
    $Globalhookmodules = array(  );
}

$Globalhookmodules = array_merge($Globalhookmodules, array( "general", "functions", "generaladmin", "pdf", "moduleadmin", "module", "functions_build", "settingadmin", "class_userfactory", "functions_misc" ));
$phrasegroups[] = "cphome";
$phrasegroups[] = "stopmsg";
$phrasegroups[] = "cpglobal";
$phrasegroups[] = "modules";
$phrasegroups[] = "dateglobal";
$phrasegroups[] = "forms";
if( !defined("CWD") ) 
{
    define("CWD", ($getcwd = getcwd()) ? $getcwd : ".");
}

ob_start();
include_once(CWD . "/include/starter.php");
include_once(DIR . "/include/functions_misc.php");
include_once(DIR . "/include/functions_dimcp.php");
require_once(DIR . "/include/functions_product.php");
include_once(DIR . "/include/class_session.php");
if( $hook->hook_exist("functions_start") ) 
{
    $hook->execute_hook("functions_start");
}

if( $dimofinf->userinfo["datemethod"] == 2 ) 
{
    $phrasegroups[] = "dateglobal";
}

init_langgroup();
$dimphrase = init_language();
$activemodules = fetch_product_list(true, true, true, false);
foreach( (array) $activemodules as $key => $value ) 
{
    $modules[] = $key;
}
$dimofinf->options["activemodules"] = !empty($modules) ? (array) $modules : array(  );
$activemodulesplugins = fetch_product_list(true, true, false, false, true);
foreach( (array) $activemodulesplugins as $key => $value ) 
{
    $modulesplugins[] = $key;
}
$dimofinf->options["contentmodulesplugins"] = !empty($modulesplugins) ? (array) $modulesplugins : array(  );
$allactivemodulesplugins = fetch_product_list(true, true, false, false);
foreach( (array) $allactivemodulesplugins as $key => $value ) 
{
    $allmodulesplugins[] = $key;
}
$dimofinf->options["allmodulesplugins"] = !empty($allmodulesplugins) ? (array) $allmodulesplugins : array(  );
$dimofinf->options["activestyles"] = !empty($dimofinf->options["activestyles"]) ? explode(",", $dimofinf->options["activestyles"]) : array(  );
$dimofinf->options["subscribtionschoices"] = !empty($dimofinf->options["subscribtionschoices"]) ? explode(",", $dimofinf->options["subscribtionschoices"]) : array(  );
$dimofinf->options["subscribtionschoices"] = !empty($dimofinf->options["subscribtionschoices"]) ? explode(",", $dimofinf->options["subscribtionschoices"]) : array(  );
$styleid = $dimofinf->GPC[COOKIE_PREFIX . "styleid"] ? $dimofinf->GPC[COOKIE_PREFIX . "styleid"] : $dimofinf->options["homestyle"];
$sessionhash = !empty($dimofinf->GPC["s"]) ? $dimofinf->GPC["s"] : $dimofinf->GPC[COOKIE_PREFIX . "sessionhash"];
define("ADMINHASH", md5(COOKIE_SALT . $dimofinf->userinfo["userid"] . $dimofinf->userinfo["salt"]));
$dimofinf->session = new DIM_Session($dimofinf, $sessionhash, $dimofinf->GPC[COOKIE_PREFIX . "userid"], $dimofinf->GPC[COOKIE_PREFIX . "password"], $styleid);
$dimofinf->session->set_session_visibility($show["search_engine"] || 0 < $dimofinf->superglobal_size["_COOKIE"]);
$dimofinf->userinfo = $dimofinf->session->fetch_userinfo();
if( !isset($dimofinf->userinfo["permissions"]) ) 
{
    $permissions = cache_permissions($dimofinf->userinfo);
}

if( !is_permissioned_to("dimcp", "cldimcp") ) 
{
    $checkpwd = 1;
}

fetch_time_data();
$cpsession = array(  );
$dimofinf->input->clean_array_gpc("p", array( "adminhash" => TYPE_STR ));
$dimofinf->input->clean_array_gpc("c", array( COOKIE_PREFIX . "cpsession" => TYPE_STR ));
if( !empty($dimofinf->GPC[COOKIE_PREFIX . "cpsession"]) ) 
{
    $cpsession = $dimofinf->db->query_first("SELECT * FROM " . TABLE_PREFIX . "cpsession \n        WHERE userid = " . intval($dimofinf->userinfo["userid"]) . "\n        AND hash = '" . $dimofinf->db->escape_string($dimofinf->GPC[COOKIE_PREFIX . "cpsession"]) . "'\n        AND datetime > " . iif($dimofinf->options["timeoutcontrolpanel"], intval(TIMENOW - $dimofinf->options["cookietimeout"]), intval(TIMENOW - 3600)));
    if( !empty($cpsession) ) 
    {
        $dimofinf->db->query_write("UPDATE LOW_PRIORITY " . TABLE_PREFIX . "cpsession \n                SET datetime = " . TIMENOW . " \n                WHERE userid = " . $dimofinf->userinfo["userid"] . " \n                AND hash = '" . $dimofinf->db->escape_string($dimofinf->GPC[COOKIE_PREFIX . "cpsession"]) . "'\n                ");
    }

}

define("CP_SESSIONHASH", $cpsession["hash"]);
$tpl_dir = ADMIN_FOLDER . "/cpstyle";
$tpl_front_dir = "styles/" . $dimofinf->stylecache[$dimofinf->options["homestyle"]]["folder"];
$img_dir = "cpstyle/img";
define("IMG_DIR", $img_dir);
define("SCRIPT_URL", $dimofinf->options["script_url"]);
define("DIM_SCRIPTS", $dimofinf->options["script_url"] . "/scripts");
define("HOME_TPL_DIR", $tpl_front_dir);
$postvars = construct_post_vars_html();
if( $checkpwd || $dimofinf->options["timeoutcontrolpanel"] && !$dimofinf->session->vars["loggedin"] || empty($dimofinf->GPC[COOKIE_PREFIX . "cpsession"]) || $dimofinf->GPC[COOKIE_PREFIX . "cpsession"] != $cpsession["hash"] || empty($cpsession) ) 
{
    $check = array(  );
    $spectemps = $db->query_read("SELECT title FROM " . TABLE_PREFIX . "datastore");
    while( $spectemp = $db->fetch_array($spectemps) ) 
    {
        $check[$spectemp["title"]] = true;
    }
    $db->free_result($spectemps);
    if( !$check["smiliecache"] ) 
    {
        require_once(DIR . "/include/functions_build.php");
        build_datastore("smiliecache", "", 1);
        build_image_cache("smilie");
    }

    if( !$check["pluginscache"] ) 
    {
        require_once(DIR . "/include/functions_build.php");
        build_plugins_datastore();
    }

    if( !$check["modulesections"] ) 
    {
        require_once(DIR . "/include/functions_build.php");
        build_module_sections();
    }

    if( !$check["stylecache"] ) 
    {
        require_once(DIR . "/include/functions_build.php");
        build_style_datastore();
    }

    if( !$check["languagecache"] ) 
    {
        require_once(DIR . "/include/functions_language.php");
        build_language();
        require_once(DIR . "/include/functions_build.php");
        build_language_datastore();
    }

    if( !$check["bookmarksitecache"] ) 
    {
        require_once(DIR . "/include/functions_build.php");
        build_bookmarksite_datastore();
    }

    if( !$check["extrablockscache"] ) 
    {
        require_once(DIR . "/include/functions_build.php");
        build_extrablocks_datastore();
    }

    if( $hook->hook_exist("global_datastore_check") ) 
    {
        $hook->execute_hook("global_datastore_check");
    }

    if( $hook->hook_exist("functions_datastore_build") ) 
    {
        $hook->execute_hook("functions_datastore_build");
    }

    if( !$check["cron"] ) 
    {
        require_once(DIR . "/include/functions_build.php");
        build_datastore("cron", "", 1);
    }

    if( !$check["usergroupcache"] ) 
    {
        require_once(DIR . "/include/functions_build.php");
        build_usergroup_datastore();
    }

    if( !$check["maxloggedin"] ) 
    {
        require_once(DIR . "/include/functions_build.php");
        build_datastore("maxloggedin", "", 1);
    }

    if( !$check["userstats"] ) 
    {
        require_once(DIR . "/include/functions_build.php");
        build_datastore("userstats", "", 1);
        build_user_statistics();
    }

    gotologin();
}
else
{
    if( $_POST["action"] && ADMINHASH != $dimofinf->GPC["adminhash"] ) 
    {
        gotologin();
    }

}

//if( THIS_SCRIPT != "verifyaccount" && !$dimofinf->options["ftpaccountverified"] ) 
//{
    //verifyaccount();
//}

$license = check_license();
if( $dimofinf->options["enablebanning"] ) 
{
    verify_ip_ban();
}

blockhack();
if( !is_permissioned_to("dimcp", "cldimcp") ) 
{
    perm_denied();
}

if( strtoupper($_SERVER["REQUEST_METHOD"]) == "POST" || THIS_SCRIPT == "vimg" || strstr($_REQUEST["action"], "save") ) 
{
    if( defined("CSRF_PROTECTION") && CSRF_PROTECTION === true ) 
    {
        $dimofinf->input->clean_array_gpc("p", array( "token" => TYPE_STR ));
        if( !in_array($_POST["action"], $dimofinf->csrf_skip_list) && !verify_token($dimofinf->GPC["token"], $dimofinf->userinfo["token_raw"]) ) 
        {
            switch( $dimofinf->GPC["token"] ) 
            {
                case "":
                    define("CSRF_ERROR", "missing");
                    break;
                case "guest":
                    define("CSRF_ERROR", "guest");
                    break;
                case "timeout":
                    define("CSRF_ERROR", "timeout");
                    break;
                default:
                    define("CSRF_ERROR", "invalid");
            }
        }

    }
    else
    {
        if( !defined("CSRF_PROTECTION") && !defined("SKIP_REFERRER_CHECK") ) 
        {
            if( $_SERVER["HTTP_HOST"] || $_ENV["HTTP_HOST"] ) 
            {
                $http_host = $_SERVER["HTTP_HOST"] ? $_SERVER["HTTP_HOST"] : $_ENV["HTTP_HOST"];
            }
            else
            {
                if( $_SERVER["SERVER_NAME"] || $_ENV["SERVER_NAME"] ) 
                {
                    $http_host = $_SERVER["SERVER_NAME"] ? $_SERVER["SERVER_NAME"] : $_ENV["SERVER_NAME"];
                }

            }

            if( $http_host && $_SERVER["HTTP_REFERER"] ) 
            {
                $http_host = preg_replace("#:80\$#", "", trim($http_host));
                $referrer_parts = @parse_url($_SERVER["HTTP_REFERER"]);
                $ref_port = intval($referrer_parts["port"]);
                $ref_host = $referrer_parts["host"] . (!empty($ref_port) && $ref_port != "80" ? ":" . $ref_port : "");
                $allowed = preg_split("#\\s+#", $dimofinf->options["allowedreferrers"], -1, PREG_SPLIT_NO_EMPTY);
                $allowed[] = preg_replace("#^www\\.#i", "", $http_host);
                $pass_ref_check = false;
                foreach( $allowed as $host ) 
                {
                    if( preg_match("#" . preg_quote($host, "#") . "\$#siU", $ref_host) ) 
                    {
                        $pass_ref_check = true;
                        break;
                    }

                }
                unset($host);
                unset($allowed);
                if( $pass_ref_check == false ) 
                {
                    exit( "In order to accept request originating from [" . $ref_host . "], the admin must add this domain to the whitelist." );
                }

            }

        }

    }

}

if( 0 < $dimofinf->userinfo["userid"] && strpos($_SERVER["HTTP_X_MOZ"], "prefetch") !== false ) 
{
    if( SAPI_NAME == "cgi" || SAPI_NAME == "cgi-fcgi" ) 
    {
        header("Status: 403 Forbidden");
    }
    else
    {
        header("HTTP/1.1 403 Forbidden");
    }

    exit( "Prefetching is not allowed due to the various privacy issues that arise." );
}

if( defined("CSRF_ERROR") ) 
{
    if( isset($_SERVER["HTTP_X_REQUESTED_WITH"]) && strtolower($_SERVER["HTTP_X_REQUESTED_WITH"]) === "xmlhttprequest" ) 
    {
        $ajaxerror = "";
    }
    else
    {
        $ajaxerror = "error";
    }

    $ajaxerror = $dimofinf->GPC["ajax"] ? "error" : "";
    switch( CSRF_ERROR ) 
    {
        case "missing":
            error_message(fetch_message("token_missing", $dimofinf->options["contactuslink"]), $ajaxerror);
            break;
        case "guest":
            error_message(fetch_message("token_guest"), $ajaxerror);
            break;
        case "timeout":
            error_message(fetch_message("token_timeout", $dimofinf->options["contactuslink"]), $ajaxerror);
            break;
        case "invalid":
        default:
            error_message(fetch_message("token_invalid", $dimofinf->options["contactuslink"]), $ajaxerror);
    }
    exit();
}

$arrdimActions = array( "doprunelog", "csvtable", "sqltable", "sqlfile", "doadd", "doedit", "remove", "kill", "remv", "quickedit", "doaddsection", "doeditsection", "remvsection", "doaddcontent", "doeditcontent", "remvcontent", "catquickedit", "remvrejected", "domassimport", "doeditpermission", "del", "rmvthumbsection", "runcron", "switchactive", "doupload", "domail", "dosysinfo", "doperm", "import", "doimport", "wmark", "doeditcat", "remv", "doaddimage", "doeditimage", "remvimage", "download", "upd", "upload", "rebuild", "setdefault", "doremv", "remv", "up_settings", "dodefault", "doaddschedule", "doeditschedule", "remvschedule", "docron", "doreply", "remv", "remvatt", "mass", "docontact", "doaddcfrm", "doeditcfrm", "doaddfgrp", "doeditfgrp", "remvcfrm", "doremvcfrm", "doremvfgrp", "doaddfield", "doeditfield", "remvfield", "doremvfield", "quickeditfields", "completeorphans", "dochangeit", "updt", "install", "doremv", "doupgrade", "activate", "deactivate", "sortplugin", "dorepair", "fixautoinc", "fixnumf", "fixunique", "dorepl", "doadd", "domodify", "dosend", "doexport", "updt", "domoderate", "doemailpassword", "doremve", "deleteprofileimage", "doaddmedia", "doeditmedia", "remvmedia", "unaprv", "doaddwin", "doeditwin", "remvwin", "dogenerate", "dopboots" );
if( in_array($_REQUEST["action"], $arrdimActions) ) 
{
}

function mk_template($var, $closreq = "", $ajax = false, $is_plugin_template = false)
{
    global $dimofinf;
    global $styleid;
    global $tpl_front_dir;
    global $tpl;
    global $tpl_dir;
    global $img_dir;
    global $dimphrase;
    global $dimhome;
    global $copyrightyear;
    global $Globalassigneds;
    global $Globaltemplates;
    global $Globalpluginstemplates;
    global $timenow;
    global $datenow;
    global $timediff;
    global $license;
    include_once(DIR . "/include/class_template.php");
    if( preg_match("#\\|#is", $var) ) 
    {
        $var = explode("|", $var);
        $var = $var[0];
    }

    if( preg_match("#\\/#is", $var) ) 
    {
        $file = explode("/", $var);
        list($tplplugin, , $tplfolder, $tplpluginfile) = $file;
    }

    if( file_exists($tpl_dir . "/" . $var) ) 
    {
        $tpl = new DIM_Template($tpl_dir . "/" . $var);
    }
    else
    {
        if( file_exists($tpl_front_dir . "/" . $tplplugin . "/" . $tplfolder . "/" . $tplpluginfile) ) 
        {
            $tpl = new DIM_Template("/" . $tpl_front_dir . "/" . $tplplugin . "/" . $tplfolder . "/" . $tplpluginfile);
        }
        else
        {
            if( file_exists("include/plugins/" . $var) ) 
            {
                $tpl = new DIM_Template("/include/plugins/" . $var);
            }
            else
            {
                exit( "<br /><b>DIM_Template Error:</b> template <u>" . htmlspecialchars($var) . "</u> not found." );
            }

        }

    }

    $tpl->enable_compilesave = false;
    $tpl->debug = $dimofinf->config["Tpl_debug"];
    if( !$dimofinf->options["dimactive"] ) 
    {
        $Globalassigneds = array_merge($Globalassigneds, array( "close_message" => fetch_message("alert_dimofinf_off") ));
    }

    if( array_keys((array) $license["addons"]) ) 
    {
        $No_Branding = 0;
        foreach( $license["addons"] as $key => $addon ) 
        {
            if( $addon["name"] == "No Branding" && $addon["status"] == "Active" ) 
            {
                $No_Branding = 1;
                break;
            }

        }
    }

    $Globalassigneds = array_merge($Globalassigneds, array( "dimcopyright" => $No_Branding ? "" : "<center><span dir=\"ltr\" class=\"smallfont\">Powered by <a title=\"Dimofinf CMS\" href=\"https://www.dimofinf.net\" target=\"_blank\">Dimofinf cms</a> Version " . $dimofinf->options["version"] . "<br />Copyright<sup>&copy;</sup> Dimensions Of Information Inc. <br /> </span></center>", "thisyear" => $copyrightyear, "dimtitle" => $dimofinf->options["dimtitle"], "version" => $dimofinf->options["version"], "domain" => $dimofinf->options["domain"], "script_url" => SCRIPT_URL, "dim_scripts" => DIM_SCRIPTS, "admin_script_url" => SCRIPT_URL . "/" . ADMIN_FOLDER, "img_dir" => $img_dir, "lang_direction" => LANG_DIR, "lang_code" => LANG_CODE, "lang_charset" => LANG_CHARSET, "lang_left" => LANG_LEFT, "lang_right" => LANG_RIGHT, "lang_larrow" => LANG_LARROW, "lang_rarrow" => LANG_RARROW, "lang_dlarrow" => LANG_DLARROW, "lang_drarrow" => LANG_DRARROW, "lang_pos" => LANG_POS, "lang_neg" => LANG_NEG, "lang_yes" => $dimphrase["yes"], "lang_no" => $dimphrase["no"] ));
    $Globalassigneds = array_merge($Globalassigneds, array( "dimhome" => getpermalink($dimofinf->options["dimhome"]) ));
    $tpl->assignGlobal($Globalassigneds);
}

function error_message($msg, $errortype = "error", $json = false)
{
    global $dimofinf;
    global $img_dir;
    global $tpl;
    if( $errortype == "error" && !$json ) 
    {
        mk_template("msgstop.htm");
        $tpl->assignGlobal(array( "msg" => $msg ));
        $tpl->printToScreen();
    }
    else
    {
        if( $json ) 
        {
            if( $errortype == "error" || $errortype == "validate" ) 
            {
                if( !is_array($msg) ) 
                {
                    $msg = array( $msg );
                }

                $json = array(  );
                $json["type"] = $errortype;
                $json["msg"] = $msg;
                echo htmlspecialchars(json_encode($json));
            }

        }
        else
        {
            header("Cache-Control: no-cache, must-revalidate");
            header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
            header("Content-Type: text/html; charset=" . LANG_CHARSET . "");
            header("Content-language: " . LANG_CODE . "");
            echo "<div style='padding:10px'>" . $msg . "</div>";
        }

    }

    exec_shut_down();
}

function success_message($msg, $reloadallpage = false, $extra = false, $aextra = false, $json = false, $redirect = false, $status = false)
{
    global $_REQUEST;
    global $dimofinf;
    global $img_dir;
    global $tpl;
    if( $json == false ) 
    {
        mk_template("msg.htm");
        $tpl->newBlock("displaymsg_block");
        if( !$reloadallpage ) 
        {
            $reloadallpage = 0;
        }

        if( $extra ) 
        {
            $tpl->assign("alextra", 1);
            $tpl->assign("extra", $extra);
        }

        if( $aextra ) 
        {
            $tpl->assign("alaextra", 1);
            $tpl->assign("aextra", $aextra);
        }

        $tpl->assign("msg", $msg);
        $tpl->assign("reloadallpage", $reloadallpage);
        $tpl->assign("reffurl", htmlspecialchars_uni($_REQUEST["reffurl"]));
        $tpl->printToScreen();
    }
    else
    {
        if( !is_array($msg) ) 
        {
            $msg = array( $msg );
        }

        $json = array(  );
        $json["type"] = "success";
        $json["msg"] = $msg;
        $json["redirect"] = $redirect;
        $json["status"] = $status;
        echo htmlspecialchars(json_encode($json));
    }

}

function gotologin()
{
    global $tpl;
    global $dimofinf;
    global $img_dir;
    global $postvars;
    mk_template("login.htm");
    $tpl->assign("postvars", $postvars);
    $tpl->newBlock("login");
    $tpl->printToScreen();
    exit();
}

function prev_next($page, $perpage, $results, $address, $address2 = "", $ajax = false, $replacediv = "")
{
    global $dimofinf;
    global $show;
    global $dimphrase;
    global $hook;
    if( in_array(THIS_SCRIPT, $dimofinf->options["allmodulesplugins"]) ) 
    {
        $address = THIS_SCRIPT . "_dimcp.php?action=" . $address;
    }
    else
    {
        $address = THIS_SCRIPT . ".php?action=" . $address;
    }

    $curpage = 0;
    $pagenavigation = "";
    $pagenav = "";
    $firstlink = "";
    $prevlink = "";
    $lastlink = "";
    $nextlink = "";
    if( $results <= $perpage ) 
    {
        $show["pagenav"] = false;
        return "";
    }

    $show["pagenav"] = true;
    $total = dim_number_format($results);
    $totalpages = ceil($results / $perpage);
    $show["prev"] = false;
    $show["next"] = false;
    $show["first"] = false;
    $show["last"] = false;
    if( 1 < $page ) 
    {
        $prevpage = $page - 1;
        $prevnumbers = fetch_start_end_total_array($prevpage, $perpage, $results);
        $show["prev"] = true;
    }

    if( $page < $totalpages ) 
    {
        $nextpage = $page + 1;
        $nextnumbers = fetch_start_end_total_array($nextpage, $perpage, $results);
        $show["next"] = true;
    }

    if( !is_array($dimofinf->options["pagenavsarr"]) ) 
    {
        $dimofinf->options["pagenavsarr"] = preg_split("#\\s+#s", $dimofinf->options["pagenavs"], -1, PREG_SPLIT_NO_EMPTY);
    }

    while( $curpage++ < $totalpages ) 
    {
        if( $dimofinf->options["offsetnavoffsets"] <= abs($curpage - $page) && $dimofinf->options["offsetnavoffsets"] != 0 ) 
        {
            if( $curpage == 1 ) 
            {
                $firstnumbers = fetch_start_end_total_array(1, $perpage, $results);
                $show["first"] = true;
            }

            if( $curpage == $totalpages ) 
            {
                $lastnumbers = fetch_start_end_total_array($totalpages, $perpage, $results);
                $show["last"] = true;
            }

            if( in_array(abs($curpage - $page), $dimofinf->options["pagenavsarr"]) && $curpage != 1 && $curpage != $totalpages ) 
            {
                $pagenumbers = fetch_start_end_total_array($curpage, $perpage, $results);
                if( $curpage != 1 ) 
                {
                    if( $ajax ) 
                    {
                        $link = "onclick=\"javascript:DIM_showinline('" . $replacediv . "','" . $address . $address2 . "&page=" . $curpage . "&ajax=ajax" . "',this); return false;";
                    }
                    else
                    {
                        $link = "href=\"" . $address . $address2 . "&page=" . $curpag . "";
                    }

                    $pagenav .= "<td><a class='cursor' " . $link . "";
                }
                else
                {
                    if( $ajax ) 
                    {
                        $link = "onclick=\"javascript:DIM_showinline('" . $replacediv . "','" . $address . $address2 . "&ajax=ajax" . "',this); return false;";
                    }
                    else
                    {
                        $link = "href=\"" . $address . $address2 . "";
                    }

                    $pagenav .= "<td><a class='cursor' " . $link . "";
                }

                if( $curpage != 1 ) 
                {
                    $pagenav .= "&amp;page=" . $curpage;
                }

                $pagenav .= "\" title=\"" . construct_phrase($dimphrase["results_x_to_y_of_z"], $pagenumbers["first"], $pagenumbers["last"], $total) . "\">" . $curpage . "</a></td>";
            }

        }
        else
        {
            if( $curpage == $page ) 
            {
                $numbers = fetch_start_end_total_array($curpage, $perpage, $results);
                $pagenav .= "<td><span class=\"selected\" title=\"" . construct_phrase($dimphrase["results_x_to_y_of_z"], $numbers["first"], $numbers["last"], $total) . "\">" . $curpage . "</span></td>";
            }
            else
            {
                $pagenumbers = fetch_start_end_total_array($curpage, $perpage, $results);
                if( $curpage != 1 ) 
                {
                    if( $ajax ) 
                    {
                        $link = "onclick=\"javascript:DIM_showinline('" . $replacediv . "','" . $address . $address2 . "&page=" . $curpage . "&ajax=ajax" . "',this); return false;";
                    }
                    else
                    {
                        $link = "href=\"" . $address . $address2 . "&page=" . $curpage . "";
                    }

                    $pagenav .= "<td><a class='cursor' " . $link . "";
                }
                else
                {
                    if( $ajax ) 
                    {
                        $link = "onclick=\"javascript:DIM_showinline('" . $replacediv . "','" . $address . $address2 . "&ajax=ajax" . "',this); return false;";
                    }
                    else
                    {
                        $link = "href=\"" . $address . $address2 . "";
                    }

                    $pagenav .= "<td><a class='cursor' " . $link . "";
                }

                $pagenav .= "\" title=\"" . construct_phrase($dimphrase["results_x_to_y_of_z"], $pagenumbers["first"], $pagenumbers["last"], $total) . "\">" . $curpage . "</a></td>";
            }

        }

    }
    if( $show["pagenav"] ) 
    {
        $pagenavigation .= "<div class=\"pageslist\" align=\"" . LANG_RIGHT . "\">\n<table>\n<tr>\n<td><span>" . construct_phrase($dimphrase["page_x_of_y"], $page, $totalpages) . "</span></td>";
        if( $show["first"] ) 
        {
            $pagenavigation .= "<td><a class='cursor' href=\"" . $address . $address2 . "\" title=\"" . $dimphrase["first_page"] . " -  " . construct_phrase($dimphrase["results_x_to_y_of_z"], $firstnumbers["first"], $firstnumbers["last"], $total) . "\">" . LANG_DLARROW . " " . $dimphrase["first"] . "</a></td>";
        }

        if( $show["prev"] ) 
        {
            if( $curpage != 1 ) 
            {
                if( $ajax ) 
                {
                    $link = "onclick=\"javascript:DIM_showinline('" . $replacediv . "','" . $address . $address2 . "&page=" . $prevpage . "&ajax=ajax" . "',this); return false;";
                }
                else
                {
                    $link = "href=\"" . $address . $address2 . "&page=" . $prevpage . "";
                }

                $pagenavigation .= "<td><a class='cursor' " . $link . "";
            }
            else
            {
                if( $ajax ) 
                {
                    $link = "onclick=\"javascript:DIM_showinline('" . $replacediv . "','" . $address . $address2 . "&ajax=ajax" . "',this); return false;";
                }
                else
                {
                    $link = "href=\"" . $address . $address2 . "";
                }

                $pagenavigation .= "<td><a class='cursor' " . $link . "";
            }

            $pagenavigation .= "\" title=\"" . $dimphrase["prev_page"] . " -  " . construct_phrase($dimphrase["results_x_to_y_of_z"], $prevnumbers["first"], $prevnumbers["last"], $total) . "\">" . LANG_LARROW . "</a></td>";
        }

        $pagenavigation .= $pagenav;
        if( $show["next"] ) 
        {
            if( $ajax ) 
            {
                $link = "onclick=\"javascript:DIM_showinline('" . $replacediv . "','" . $address . $address2 . "&page=" . $nextpage . "&ajax=ajax" . "',this); return false;";
            }
            else
            {
                $link = "href=\"" . $address . $address2 . "&page=" . $nextpage . "";
            }

            $pagenavigation .= "<td><a class='cursor' " . $link . "";
            $pagenavigation .= "\" title=\"" . $dimphrase["next_page"] . " -  " . construct_phrase($dimphrase["results_x_to_y_of_z"], $nextnumbers["first"], $nextnumbers["last"], $total) . "\">" . LANG_RARROW . "</a></td>";
        }

        if( $show["last"] ) 
        {
            if( $ajax ) 
            {
                $link = "onclick=\"javascript:DIM_showinline('" . $replacediv . "','" . $address . $address2 . "&page=" . $totalpages . "&ajax=ajax" . "',this); return false;";
            }
            else
            {
                $link = "href=\"" . $address . $address2 . "&page=" . $totalpages . "";
            }

            $pagenavigation .= "<td><a class='cursor' " . $link . "";
            $pagenavigation .= "\" class='cursor' title=\"" . $dimphrase["last_page"] . " -  " . construct_phrase($dimphrase["results_x_to_y_of_z"], $lastnumbers["first"], $lastnumbers["last"], $total) . "\">" . $dimphrase["last"] . " " . LANG_DRARROW . "</a></td>";
        }

        $pagenavigation .= "</tr>\n\t\t\t\t\t</table>\n\t\t\t\t\t</div>";
    }

    return $pagenavigation;
}

function fetch_start_end_total_array($page, $perpage, $total)
{
    $first = $perpage * ($page - 1);
    $last = $first + $perpage;
    if( $total < $last ) 
    {
        $last = $total;
    }

    $first++;
    return array( "first" => dim_number_format($first), "last" => dim_number_format($last) );
}

function unclean($var)
{
    $var = stripslashes($var);
    $var = str_replace("&amp;", "&", $var);
    $var = str_replace("&gt;", ">", $var);
    $var = str_replace("&lt;", "<", $var);
    $var = str_replace("&quot;", "\"", $var);
    return $var;
}

function bbcodeparse_for_display($bbcode)
{
    $bbcode = preg_replace("#<script(.*?)>(.*?)</script>#is", "", str_replace(array( "'", "\"" ), array( "&#39;", "&quot;" ), $bbcode));
    return strip_tags($bbcode);
}

function bbcodeparse($bbcode, $addnl2br = false, $tooltip = false)
{
    global $dimofinf;
    require_once(DIR . "/include/class_bbcode.php");
    $bbcode_parser = new DIM_BbCodeParser($dimofinf, fetch_tag_list());
    return $bbcode_parser->parse($bbcode, iif($dimofinf->options["allowsmilies"], 1, 0), $addnl2br);
}

function maketree($mktreerootcatid, $mktreemaxlevel, $mktreesec, $mktreeaccordion = false, $mktreeselectlist = false, $mktreeselectid = false)
{
    global $dimofinf;
    $mktreelist = get_items_from_data_store_by_tbl_name($mktreesec, $mktreeselectid);
    $mktreecount = count($mktreelist);
    foreach( $mktreelist as $mktreerow ) 
    {
        $table[$mktreerow["mother"]][$mktreerow["id"]] = array( "name" => htmlspecialchars_uni($mktreerow["name"]), "numf" => $mktreerow["numf"], "picture" => $mktreerow["picture"], "mother" => $mktreerow["mother"], "active" => $mktreerow["active"], "displayorder" => (int) $mktreerow["displayorder"], "supplement" => $mktreerow["supplement"], "special_perm" => $mktreerow["special_perm"] ? 1 : 0, "inherit_perm" => $mktreerow["inherit_perm"] ? $mktreerow["inherit_perm"] : 0 );
    }
    return makebranch($mktreerootcatid, $table, 0, $mktreemaxlevel, $mktreesec, $mktreecount, $mktreeaccordion, $mktreeselectlist, $mktreeselectid);
}

function makebranch($branchparcat, $branchtable, $branchlevel, $maxlevel, $branchsec, $branchcount = false, $accordion = false, $branchselectlist = false, $branchselectid = false)
{
    global $tpl;
    global $img_dir;
    global $dimofinf;
    global $dimphrase;
    $branchlist = $branchtable[$branchparcat];
    if( !empty($branchlist) ) 
    {
        foreach( $branchlist as $key => $val ) 
        {
            if( $branchselectlist ) 
            {
                if( $branchlevel == "0" ) 
                {
                    $output = "";
                }
                else
                {
                    $dashes = "";
                    for( $i = 1; $i < $branchlevel; $i++ ) 
                    {
                        $dashes .= "-";
                    }
                    $output = $dashes;
                }

                $tpl->newBlock("mother");
                $tpl->assign(array( "mname" => $output . " " . htmlspecialchars_uni($val["name"]), "option" => $key ));
                if( $key == $branchselectid || in_array($key, (array) $branchselectid) ) 
                {
                    $tpl->assign("sel", " selected");
                }

                if( isset($branchtable[$key]) && ($branchlevel + 1 < $maxlevel || $maxlevel == "0") ) 
                {
                    makebranch($key, $branchtable, $branchlevel + 1, $maxlevel, $branchsec, true, $accordion, $branchselectlist, $branchselectid);
                }

            }
            else
            {
                if( $branchlevel == "0" ) 
                {
                    $output = "<img src=\"" . SCRIPT_URL . "/images/subs/se.gif\" width=\"12\" height=\"12\" /> ";
                }
                else
                {
                    $width = $branchlevel * 12;
                    $output = "<img src=\"" . SCRIPT_URL . "/images/subs/e.gif\" width=\"" . $width . "\" height=\"12\" /><img border=0 src=\"" . SCRIPT_URL . "/images/subs/se" . $branchlevel . ".gif\" width=\"12\" height=\"12\" /> ";
                }

                $tpl->newBlock("menu");
                $tpl->assign("id", $key);
                if( $branchlevel == "0" && $accordion ) 
                {
                    $tpl->newBlock("menu", "accordionstart");
                    $tpl->gotoBlock("menu");
                    $tpl->assign("accordion", "on");
                }

                if( $val["active"] ) 
                {
                    $tpl->assign("status", "on");
                }
                else
                {
                    $tpl->assign("status", "off");
                }

                $tpl->assign($branchsec . "s_name", $output . htmlspecialchars_uni($val["name"]));
                $tpl->assign("mother_id", $key);
                $tpl->assign("picture", $val["picture"]);
                $numftotal = $dimofinf->db->query_first_slave("SELECT numf AS total FROM " . TABLE_PREFIX . $dimofinf->pluginscache["" . $branchsec . ""]["section_table"] . " WHERE id = '" . $key . "'");
                $tpl->assign("count", $numftotal["total"]);
                $tpl->assign("special_perm", $val["special_perm"]);
                $tpl->assign("inherit_perm", in_array($key, explode(",", $dimofinf->modulesections[$branchsec][$dimofinf->GPC["id"]]["inherit_perm"])));
                $tpl->assign("displayorder", (int) $val["displayorder"]);
                if( $val["supplement"] ) 
                {
                    $tpl->assign("supplement", $val["supplement"]);
                }

                if( isset($branchtable[$key]) && ($branchlevel + 1 < $maxlevel || $maxlevel == "0") ) 
                {
                    if( $branchlevel == "0" && $accordion ) 
                    {
                        $tpl->assign("haschildrens", "on");
                    }

                    makebranch($key, $branchtable, $branchlevel + 1, $maxlevel, $branchsec, true, $accordion, $branchselectlist, $branchselectid);
                }

                if( $branchlevel == "0" && $accordion ) 
                {
                    $tpl->newBlock("menu", "accordionend");
                }

            }

        }
        unset($key);
        unset($val);
    }

    return $branchcount;
}

function g_and_s_bi_file($sourcefile, $targetfile, $noreport = "")
{
    $contents = read_file_contents($sourcefile, "rb");
    if( $tp = @fopen($targetfile, "wb") ) 
    {
        @fwrite($tp, $contents);
        @fclose($tp);
        return $contents;
    }

    return false;
}

function print_error_message($phrasename, $var = "", $var2 = "")
{
    global $dimofinf;
    global $dimphrase;
    $message = fetch_message($phrasename, $var, $var2);
    if( defined("CP_CONTINUE") ) 
    {
        define("CP_REDIRECT", CP_CONTINUE);
    }

    print_cp_message($message, defined("CP_REDIRECT") ? CP_REDIRECT : NULL, 1, defined("CP_BACKURL") ? CP_BACKURL : NULL, defined("CP_CONTINUE") ? true : false);
    return $message;
}

function redirect($gotopage, $timeout = 1, $extra = false)
{
    global $dimphrase;
    print_cp_header();
    if( $extra ) 
    {
        echo $extra;
    }

    $gotopage = str_replace("&amp;", "&", $gotopage);
    if( $timeout == 0 ) 
    {
        echo "<p align=\"center\" class=\"smallfont\"><a href=\"" . $gotopage . "\">" . $dimphrase["redirecting_please_wait"] . "</a></p>";
        echo "\n<script type=\"text/javascript\">\n";
        echo "window.location=\"" . $gotopage . "\";";
        echo "\n</script>\n";
    }
    else
    {
        echo "\n<script type=\"text/javascript\">\n";
        echo "myvar = \"\"; timeout = " . $timeout * 10 . ";\n\t\tfunction exec_refresh()\n\t\t{\n\t\t\twindow.status=\"" . $dimphrase["redirecting_please_wait"] . "\"+myvar; myvar = myvar + \" .\";\n\t\t\ttimerID = setTimeout(\"exec_refresh();\", 100);\n\t\t\tif (timeout > 0)\n\t\t\t{ timeout -= 1; }\n\t\t\telse { clearTimeout(timerID); window.status=\"\"; window.location=\"" . $gotopage . "\"; }\n\t\t}\n\t\texec_refresh();";
        echo "\n</script>\n";
        echo "<p align=\"center\" class=\"smallfont\"><a href=\"" . $gotopage . "\" onclick=\"javascript:clearTimeout(timerID);\">" . $dimphrase["next_page"] . "</a></p>";
    }

    print_cp_footer();
    exit();
}

function gzsavefile($file, $content)
{
    if( $zp = @gzopen($file, "wb9") ) 
    {
        @gzwrite($zp, $content);
        @gzclose($zp);
        return true;
    }

    return false;
}

function blockhack()
{
    global $_SERVER;
    global $dimofinf;
    global $tpl;
    global $dimphrase;
    $req = $_SERVER["REQUEST_URI"];
    $cadena = explode("?", $req);
    $mi_url = $cadena[0];
    $resto = rawurldecode($cadena[1]);
    $inyecc = "/script|applet|object|meta|<|>|'|\"|\\{|\\}|select|union|concat|update|and|where|alter|replace|delete|form|exe|exec|insert|tmp|left|right|inner|join/i";
    if( preg_match($inyecc, strtolower($resto), $matches) ) 
    {
        error_message(fetch_message("invalid_data_sent") . "( <span style=\"color: #ff0000\">" . $matches[0] . "</span> )");
    }

}

function verify_cp_sessionhash($halt = true, $input = "hash")
{
    global $dimofinf;
    if( !isset($dimofinf->GPC[$input]) ) 
    {
        $dimofinf->input->clean_array_gpc("r", array( $input => TYPE_STR ));
    }

    if( $dimofinf->GPC[$input] != CP_SESSIONHASH ) 
    {
        if( $halt ) 
        {
            error_message($input . ":" . fetch_message("security_alert_hash_mismatch"));
        }
        else
        {
            return false;
        }

    }

    return true;
}

function verify_token($request_token, $user_token)
{
    global $dimofinf;
    if( strpos($request_token, "-") === false ) 
    {
        return $request_token === $user_token;
    }

    list($time, $token) = explode("-", $request_token);
    if( $token !== sha1($time . $user_token) ) 
    {
        return false;
    }

    if( $time <= TIMENOW - 10800 ) 
    {
        $dimofinf->GPC["token"] = "timeout";
        return false;
    }

    return true;
}

function recursive($dinamic_cat_id = 0, $mother = "", $numf = "", $module = "", $rate = "")
{
    global $dimofinf;
    global $recursive_id;
    global $fixed_cat_id;
    if( !isset($fixed_cat_id) ) 
    {
        $fixed_cat_id = $dinamic_cat_id;
    }

    if( !empty($mother) ) 
    {
        $row = $dimofinf->db->query_first_slave("SELECT " . $mother . " FROM " . TABLE_PREFIX . $module . " WHERE id = " . (int) $dinamic_cat_id . "");
    }
    else
    {
        $row = array( "mother" => 0 );
    }

    if( $row[$mother] == 0 ) 
    {
        if( is_array($dinamic_cat_id) ) 
        {
            $fixed_cat_id = 0;
            $emplode_string = implode("','", $dinamic_cat_id);
        }
        else
        {
            $emplode_string = implode("','", (array) $recursive_id);
        }

        preg_match("#^[+]#i", $rate, $rateplus);
        $dimofinf->db->query_write("UPDATE " . TABLE_PREFIX . $module . " SET " . $numf . "=" . ($rate == "+1" || $rateplus[0] == "+" ? "" . $numf . "" . $rate : "IF(" . $numf . "," . $numf . "" . $rate . "," . $numf . ") ") . " WHERE id IN " . ($emplode_string ? "('" . $fixed_cat_id . "','" . $emplode_string . "')" : "('" . $fixed_cat_id . "')"));
    }
    else
    {
        if( 0 < (int) $row[$mother] ) 
        {
            $recursive_id[] = $row[$mother];
            recursive($row[$mother], $mother, $numf, $module, $rate);
        }
        else
        {
            unset($dinamic_cat_id);
            unset($module);
            unset($fixed_cat_id);
            unset($emplode_string);
        }

    }

}

function addmagnify()
{
    global $dimofinf;
    global $dimphrase;
    if( !$dimofinf->globaldimvars["doneaddingmagnify"] ) 
    {
        $magnifyexp = "<q>" . $dimphrase["click_to_see_ful_size"] . "</q>";
        $dimofinf->globaldimvars["jscode"] .= "\n\$(window).load(function () {\n\$(\".thumb\").each(function() {\nimageWidth = \$(this).width();\nif(imageWidth > " . $dimofinf->options["magnify_image_width"] . "){\n\$(this).attr({\n'width': '" . $dimofinf->options["magnify_image_width"] . "',\n'class': 'magnify',\n'data-magnifyto': imageWidth,\n});\n\$(this).after('" . $magnifyexp . "');\n}\n});\nvar \$targets=\$(\".magnify\");\$targets.each(function(i){var \$target=\$(this);var options={};if(\$target.attr(\"data-magnifyto\")){options.magnifyto=parseFloat(\$target.attr(\"data-magnifyto\"))}if(\$target.attr(\"data-magnifyby\")){options.magnifyby=parseFloat(\$target.attr(\"data-magnifyby\"))}if(\$target.attr(\"data-magnifyduration\")){options.duration=parseInt(\$target.attr(\"data-magnifyduration\"))}\$target.imageMagnify(options)});var \$triggers=\$('a[rel^=\"magnify[\"]');\$triggers.each(function(i){var \$trigger=\$(this);var targetid=\$trigger.attr(\"rel\").match(/\\[.+\\]/)[0].replace(/[\\[\\]']/g,\"\");\$trigger.data(\"magnifyimageid\",targetid);\$trigger.click(function(e){\$(\"#\"+\$(this).data(\"magnifyimageid\")).trigger(\"click.magnify\");e.preventDefault()})})});\n";
        $dimofinf->globaldimvars["doneaddingmagnify"] = 1;
    }

}

function filesize2bytes($str)
{
    $bytes = 0;
    $bytes_array = array( "B" => 1, "K" => 1024, "M" => 1024 * 1024, "G" => 1024 * 1024 * 1024, "T" => 1024 * 1024 * 1024 * 1024, "P" => 1024 * 1024 * 1024 * 1024 * 1024 );
    $bytes = floatval($str);
    if( preg_match("#([KMGTP]?)\$#si", $str, $matches) && !empty($bytes_array[$matches[1]]) ) 
    {
        $bytes *= $bytes_array[$matches[1]];
    }

    $bytes = intval(round($bytes, 1));
    return $bytes;
}

function ini_size_to_bytes($value)
{
    $value = trim($value);
    $retval = intval($value);
    switch( strtolower($value[strlen($value) - 1]) ) 
    {
        case "g":
            $retval *= 1024;
        case "m":
            $retval *= 1024;
        case "k":
            $retval *= 1024;
    }
    return $retval;
}

function parse_rss_feeds($url, $limit = false)
{
    $xml = parse_xml_by_simplexml(fopen_by_curl($url));
    $ns = array( "content" => "http://purl.org/rss/1.0/modules/content/", "wfw" => "http://wellformedweb.org/CommentAPI/", "dc" => "http://purl.org/dc/elements/1.1/" );
    $array = array(  );
    $array["title"] = (string) $xml->channel->title;
    $array["link"] = (string) $xml->channel->link;
    $array["description"] = (string) $xml->channel->description;
    $array["pubDate"] = (string) $xml->pubDate;
    $array["timestamp"] = (string) strtotime($xml->pubDate);
    $array["generator"] = (string) $xml->generator;
    $array["language"] = (string) $xml->language;
    $counter = 0;
    if( is_array($xml->channel->item) && !empty($xml->channel->item) ) 
    {
        foreach( $xml->channel->item as $item ) 
        {
            if( $limit && $counter == $limit ) 
            {
                break;
            }

            $article = array(  );
            $article["title"] = (string) $item->title;
            $article["link"] = (string) $item->link;
            $article["comments"] = (string) $item->comments;
            $article["pubDate"] = (string) $item->pubDate;
            $article["timestamp"] = (string) strtotime($item->pubDate);
            $article["description"] = (string) (string) trim($item->description);
            $article["isPermaLink"] = (bool) $item->guid["isPermaLink"];
            $content = $item->children($ns["content"]);
            $dc = $item->children($ns["dc"]);
            $wfw = $item->children($ns["wfw"]);
            $article["creator"] = (string) $dc->creator;
            foreach( $dc->subject as $subject ) 
            {
                $article["subject"][] = (string) $subject;
            }
            $article["content"] = (string) trim($content->encoded);
            $article["commentRss"] = (string) $wfw->commentRss;
            $array["item"][] = $article;
            $counter++;
        }
        return $array;
    }

}

function print_usergroups($varname, $inrow = 3, $selected = array(  ))
{
    global $dimofinf;
    $cell = 0;
    $output = "";
    foreach( $dimofinf->usergroupcache as $key => $group ) 
    {
        $checked = "";
        if( in_array($group["usergroupid"], $selected) ) 
        {
            $checked = " checked=\"checked\"";
        }

        $output .= "<div style=\"float: left; width: 33%;\"><input type=\"checkbox\" name=\"" . $varname . "[]\" value=\"" . $group["usergroupid"] . "\"" . $checked . " /> " . iif($dimphrase[$group["title"]] == "", $group["title"], $dimphrase[$group["title"]]) . "</div>";
        $cell++;
        if( $cell == $inrow ) 
        {
            $output .= "<div style=\"clear:both;\"></div>";
            $cell = 0;
        }

    }
    return $output;
}

function dimofinf_show_zone($plugin_id)
{
    global $dimofinf;
    $zones = array( "CONTENT_START", "CONTENT_END", "CONTENT_SERVICES_START", "CONTENT_SERVICES_END", "CONTENT_TOOLS", "CONTENT_ZONE_BEFORE", "CONTENT_ZONE_AFTER", "BY_USER_BAR" );
    $data = "<select name=\"" . $plugin_id . "_zone\">";
    foreach( $zones as $key => $value ) 
    {
        $selected = $dimofinf->options[$plugin_id . "_zone"] == $value ? "selected" : "";
        $data .= "<option value=\"" . $value . "\" " . $selected . " >" . $value . "</option>";
    }
    $data .= "</select>";
    return $data;
}

//function verifyaccount()
//{
   // global $tpl;
   // global $dimofinf;
   // mk_template("verifyaccount.htm");
   // $tpl->newBlock("data");
   // $tpl->assignglobal("storeinfo", fetch_message("storedata"));
    //$tpl->printToScreen();
  //  exit();
//}


