//ajax
var intervalid;
var intervalval = 0;
var total_steps = steps.length;

$(document).ready(function(){
	$("#action-step").css("display","block");
	
	var urlstep = getQuerystring('step');
	var urlstepq = getQuerystring('stepq')?getQuerystring('stepq'):0;
	
	if(urlstep != "")
	{
		obj = { action: 'step', step: urlstep, stepq: urlstepq };
		$("#action-step").click(function(){
			installdimofinf(obj);
		});
	}else{
	$("#action-step").click(function(){
		installdimofinf();
	});
	}
});

function installdimofinf( obj )
{
	// handle substep with ajax send paramters
	obj = typeof obj !== 'undefined' ? obj : { action: 'step', step: $("#action-step").attr('data-step'), stepq: $("#action-step").attr('data-stepq') };
       var icons_steps = [];
        var cssicon = "style='margin:0px 10px;'";
        
        icons_steps[1]="<span class='icon-cogs' "+cssicon+"></span>";
        icons_steps[2]="<span class='icon-new' "+cssicon+"></span>";
        icons_steps[3]="<span class='icon-new' "+cssicon+"></span>";
        icons_steps[4]="<span class='icon-new' "+cssicon+"></span>";
        icons_steps[5]="<span class='icon-new' "+cssicon+"></span>";
        icons_steps[6]="<span class='icon-new' "+cssicon+"></span>";
        icons_steps[7]="<span class='icon-checkmark-circle' "+cssicon+"></span>";
    
	$("#action-step").hide();
	$(".step_det").remove();
	$("#img-steps").attr( "class", "upgrade-step-"+$("#action-step").attr('data-step')+"");
	$("#div-content").html("<p class='title-steps-bg'>"+icons_steps[$("#action-step").attr('data-step')]+steps[$("#action-step").attr('data-step')]+"</p>");
	$("#loading-progress").fadeIn();
	
	if($("#action-step").attr('data-step') == 1)
	{
		$("#loading-progress").fadeIn();
		$('.ui-progress').css({ width: Math.round(1/total_steps*100)+'%' }, 1000);
		$('.value').empty();
		$('.value').html(Math.round(1/total_steps*100)+'%');
	}
	$.ajax(
			{
				url: 'upgrade_200.php',
				type: 'POST',
				timeout: 0,
				data: obj,
    error: function(xhr, textStatus, errorThrown)
    {
       setTimeout(installdimofinf, 1000, obj);
    }
			}
		)
		
	    .fail(function(x,t) 
	    {
	        if(t==="timeout") 
	        {
	        	$('[id="loading"]').remove();
	        	$("#action-step").fadeIn();
	            $("#action-step").val('Retry');
	        }
	    })
    	
		.done(function(data){
		try{
			data = JSON.parse(data);
		}catch (e){
			$("#action-step").val('Retry');
			$("#action-step").show();
			$("#result-steps").html( data ); // NOT AJAX DATA
			
			return;
		}
		if(data[0] == 'success')
		{
			st = $("#action-step").attr('data-step');
			
			if(st == 7)
			{
				$("#loadingimg").remove();
				$("#result-steps").html(data[1]);
				$(".divsmall").hide();
				$("#page").css("padding-left","0");
				$(".big_Content").css("float","none");
				$("#action-step").hide();
			}
			else
			{
				st = $("#action-step").attr('data-step');
				var step = Number($("#action-step").attr('data-step'));			
				setTimeout(installdimofinf, 1000);
				$('.ui-progress').animate({ width: Math.round(($("#action-step").attr('data-step')/(total_steps-1)*100))+'%' }, 1000);
				$('.value').empty();
				$('.value').html(Math.round(($("#action-step").attr('data-step')/(total_steps-1)*100))+'%');
				$('.ui-label').fadeIn();
				$("#action-step").attr('data-skip','false');	
				$("#result-steps").empty();
				$("#action-step").attr('data-step', Number($("#action-step").attr('data-step'))+1);
				$("#action-step").attr('data-stepq', 0);
			}
		}
		else if(data[0] == 'redirect')
		{
			// handle substep with ajax extract paramters
			var obj = JSON.parse('{"' + decodeURI(data[1].replace(/&/g, "\",\"").replace(/=/g,"\":\"")) + '"}');
			var text = '';
				
			if( obj.step )
			{
				text += 'Step: ' + obj.step;
				$("#action-step").attr('data-step', Number(obj.step));
			}
			
			if( obj.stepq )
			{
				text += ' / ' + obj.stepq;
				$("#action-step").attr('data-stepq', Number(obj.stepq));
			}
			
			$("#result-steps").html( text );
			
			setTimeout(installdimofinf, 1000, obj);
			$("#action-step").attr('data-skip','false');
		}
		else
		{
			if(data[2])
			{
				var obj = JSON.parse('{"' + decodeURI(data[2].replace(/&/g, "\",\"").replace(/=/g,"\":\"")) + '"}');
				var text = '';
					
				if( obj.step )
				{
					$("#action-step").attr('data-step', Number(obj.step));
				}
				
				if( obj.stepq )
				{
					$("#action-step").attr('data-stepq', Number(obj.stepq));
				}
			}
			
			$("#action-step").val('Retry');
			$("#action-step").show();
			$("#result-steps").html(data[1]);
		}	
	});
}

function getQuerystring(key, default_)
{
  if (default_==null) default_="";
  key = key.replace(/[\[]/,"\\\[").replace(/[\]]/,"\\\]");
  var regex = new RegExp("[\\?&]"+key+"=([^&#]*)");
  var qs = regex.exec(window.location.href);
  if(qs == null)
    return default_;
  else
    return qs[1];
}