/* JQuery Cookie */

(function($) {

	$.fn.resize_img = function(options) {
		var settings = {};
		if (options) {
			$.extend(settings, options);
		}
		var $this = $(this);
		$.each($this, function(index) {
			var $element = $this.eq(index);
			var $size_data = String($element.attr("data-size"));
			var $array_size = $size_data.split("-");
			if ($array_size.length > 0) {
				var $this_width = $array_size[0];
				var $this_height = $array_size[1];
				$element.css({
					'width': $this_width,
					'height': $this_height
				});
				$element.removeAttr('data-size');
			}
		});
	};
})(jQuery);



$(document).ready(function(){
	/*DropDown meanu*/
	$(".navbar li.dropdown").hover(function(){
		$(" > ul",this).stop().slideDown();
	},function(){
		$(" > ul",this).stop().slideUp();
	});

	$(".yesnoswitcher").btn_switch();
	$(".yesnoswitcher2").btn_switch({
		switcher_value: '0'
	});
	
	$(".input-group .dropdown-menu li").on('click', function() {
		var $val = $(this).attr("data-value");
		$('.search_type').val($val);
		$('.dropdown-toggle .text, .dropdown-toggle .searchin').text($(this).text());
	});
	$('[data-size]').resize_img();

	$("[data-toggle='tooltip']").tooltip();
	$("[data-toggle=popover]").popover({trigger: 'hover',html:true});
	$(".container").append($("#moduleLoader"));
	$('#CarouselMultimg').carousel();

	/* tabs script*/
	$(function() {
		$('#extrablock a').click(function(e) {
			e.preventDefault();
			$(this).tab('show');
		});
	});

	$('#contactli').appendTo("ul#sidemenucon");
	$('#sitemapli').appendTo("ul#sidemenucon");
	$('#sayings').insertBefore("#contactli");
	$('#guestbook').insertBefore("#contactli");

	/* Header / Search */
	var searchsourceArr = [];
	var searchsourceArr2 = [];

	$("#search ul.dropdown-menu li").click(function() {
		$("button[name='relsearchin']").find("span.in").text($(this).text());
		$("input[name='searchin']").val($(this).attr("data-value"));
		$(".searchin").html($(this).attr("data-name"));

	});


	$(window).scroll(function() {
		if ($(this).scrollTop() > 100) {
			$('#to_top').fadeIn();
		} else {
			$('#to_top').fadeOut();
		}
	});

	$('#to_top').click(function() {
		$("html, body").animate({scrollTop: 0}, 600);
		return false;
	});

	if ($.cookie('displayMod'))
		$(".display-mods").attr('id', $.cookie('displayMod'));

	if ($.cookie('displayMod') == "list_mod") {
		$(".display-options a").removeClass("active");
		$(".display-options a.glyphicon-align-justify").addClass("active");
	}
	if ($.cookie('displayMod') == "normal_mod") {
		$(".display-options a").removeClass("active");
		$(".display-options a.glyphicon-th").addClass("active");
	}
	$(".display-options a.glyphicon-align-justify").click(function() {
		$(".display-options a").removeClass("active");
		$(this).addClass("active");
		$(".display-mods").fadeOut(0);
		$(".display-mods").fadeIn(1000);
		$(".display-mods").attr('id', "list_mod");
		$.cookie("displayMod", "list_mod", {expires: 300});
	});
	$(".display-options a.glyphicon-th").click(function() {
		$(".display-options a").removeClass("active");
		$(this).addClass("active");
		$(".display-mods").fadeOut(0);
		$(".display-mods").fadeIn(1000).attr('id', "normal_mod");
		$.cookie("displayMod", "normal_mod", {expires: 300});
	});

	$(".dim_menu").on("click", "ul", function(e) {
		e.stopPropagation();
	});
	$(".dim_menu").on("click", "ul > li", function(e) {
		$(this).toggleClass("collapsed");
		$(" > ul",this).slideToggle();
	});
	var is_chrome = navigator.userAgent.toLowerCase().indexOf('chrome') > -1;
	
	// Select Style
	$("#StyleSwitcher li a").click(function() {
		$("link#SelectedStyle").attr("href", $(this).attr('rel'));
		$.cookie("css", $(this).attr('rel'), {expires: 365, path: '/'});
		return false;
	});
	if ($.cookie("css") && activestyle == 1) {
		$("link#SelectedStyle").attr("href", $.cookie("css"));
	}
	/* this code for file login.htm */
	$('#signinform').Dimiframe({
		DimiframeID: 'dimiframe',
		post: function() { },
		validateComplete: function(response) {
			if (response.type == "success") {
				refreshSignedinBox();
			}
		}, complete: function(response) {

		}
	});
	
});